/******************************************************************************
*
*  ag0Vars.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  variable declarations for TrigTracks, VolTracks, CTRLTracks, and KS/DelaySyn
*  buffers.  additional declarations for project-specific variables placed in
*  here.
*
******************************************************************************/

.MODULE                                     modag0Vars;

#define     SONGVAR_FUNC


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "ag0.h"

/*
 *  insert project-specific variables here.  make all varaibles external in the
 *  .\hdr\---vars.h file (where --- is the name of the project).
 */

.VAR/DM         a_agMedFreq[MELODICTRACKS];
.GLOBAL         a_agMedFreq;
                
.VAR/DM         a_agFreqRange[MELODICTRACKS];
.GLOBAL         a_agFreqRange;
                
.VAR/DM         a_agRandomness[MELODICTRACKS];
.GLOBAL         a_agRandomness;
                
.VAR/DM         a_agDischordancy[MELODICTRACKS];
.GLOBAL         a_agDischordancy;
                
.VAR/DM         a_agLastNotes[MELODICTRACKS];
.GLOBAL         a_agLastNotes;

/*
 *  sequencer varaibles.  do not touch!
 */

.VAR/DM/CIRC    a_TrigTrack00[LENTRACK00];
.GLOBAL         a_TrigTrack00;

.VAR/DM/CIRC    a_TrigTrack01[LENTRACK01];
.GLOBAL         a_TrigTrack01;

.VAR/DM/CIRC    a_TrigTrack02[LENTRACK02];
.GLOBAL         a_TrigTrack02;

.VAR/DM/CIRC    a_TrigTrack03[LENTRACK03];
.GLOBAL         a_TrigTrack03;

.VAR/DM/CIRC    a_TrigTrack04[LENTRACK04];
.GLOBAL         a_TrigTrack04;

.VAR/DM/CIRC    a_TrigTrack05[LENTRACK05];
.GLOBAL         a_TrigTrack05;

.VAR/DM/CIRC    a_TrigTrack06[LENTRACK06];
.GLOBAL         a_TrigTrack06;

.VAR/DM/CIRC    a_TrigTrack07[LENTRACK07];
.GLOBAL         a_TrigTrack07;

.VAR/DM/CIRC    a_TrigTrack08[LENTRACK08];
.GLOBAL         a_TrigTrack08;

.VAR/DM/CIRC    a_TrigTrack09[LENTRACK09];
.GLOBAL         a_TrigTrack09;

.VAR/DM/CIRC    a_TrigTrack10[LENTRACK10];
.GLOBAL         a_TrigTrack10;

.VAR/DM/CIRC    a_TrigTrack11[LENTRACK11];
.GLOBAL         a_TrigTrack11;

.VAR/DM/CIRC    a_TrigTrack12[LENTRACK12];
.GLOBAL         a_TrigTrack12;

.VAR/DM/CIRC    a_TrigTrack13[LENTRACK13];
.GLOBAL         a_TrigTrack13;

.VAR/DM/CIRC    a_TrigTrack14[LENTRACK14];
.GLOBAL         a_TrigTrack14;

.VAR/DM/CIRC    a_TrigTrack15[LENTRACK15];
.GLOBAL         a_TrigTrack15;

.VAR/DM/CIRC    a_TrigTrack16[LENTRACK16];
.GLOBAL         a_TrigTrack16;

.VAR/DM/CIRC    a_TrigTrack17[LENTRACK17];
.GLOBAL         a_TrigTrack17;

.VAR/DM/CIRC    a_TrigTrack18[LENTRACK18];
.GLOBAL         a_TrigTrack18;

.VAR/DM/CIRC    a_TrigTrack19[LENTRACK19];
.GLOBAL         a_TrigTrack19;

.VAR/DM/CIRC    a_TrigTrack20[LENTRACK20];
.GLOBAL         a_TrigTrack20;

.VAR/DM/CIRC    a_TrigTrack21[LENTRACK21];
.GLOBAL         a_TrigTrack21;

.VAR/DM/CIRC    a_TrigTrack22[LENTRACK22];
.GLOBAL         a_TrigTrack22;

.VAR/DM/CIRC    a_TrigTrack23[LENTRACK23];
.GLOBAL         a_TrigTrack23;

.VAR/DM/CIRC    a_TrigTrack24[LENTRACK24];
.GLOBAL         a_TrigTrack24;

.VAR/DM/CIRC    a_TrigTrack25[LENTRACK25];
.GLOBAL         a_TrigTrack25;

.VAR/DM/CIRC    a_TrigTrack26[LENTRACK26];
.GLOBAL         a_TrigTrack26;

.VAR/DM/CIRC    a_TrigTrack27[LENTRACK27];
.GLOBAL         a_TrigTrack27;

.VAR/DM/CIRC    a_TrigTrack28[LENTRACK28];
.GLOBAL         a_TrigTrack28;

.VAR/DM/CIRC    a_TrigTrack29[LENTRACK29];
.GLOBAL         a_TrigTrack29;

.VAR/DM/CIRC    a_TrigTrack30[LENTRACK30];
.GLOBAL         a_TrigTrack30;

.VAR/DM/CIRC    a_TrigTrack31[LENTRACK31];
.GLOBAL         a_TrigTrack31;

.VAR/DM/CIRC    a_VolTrack00[LENTRACK00];
.GLOBAL         a_VolTrack00;

.VAR/DM/CIRC    a_VolTrack01[LENTRACK01];
.GLOBAL         a_VolTrack01;

.VAR/DM/CIRC    a_VolTrack02[LENTRACK02];
.GLOBAL         a_VolTrack02;

.VAR/DM/CIRC    a_VolTrack03[LENTRACK03];
.GLOBAL         a_VolTrack03;

.VAR/DM/CIRC    a_VolTrack04[LENTRACK04];
.GLOBAL         a_VolTrack04;

.VAR/DM/CIRC    a_VolTrack05[LENTRACK05];
.GLOBAL         a_VolTrack05;

.VAR/DM/CIRC    a_VolTrack06[LENTRACK06];
.GLOBAL         a_VolTrack06;

.VAR/DM/CIRC    a_VolTrack07[LENTRACK07];
.GLOBAL         a_VolTrack07;

.VAR/DM/CIRC    a_VolTrack08[LENTRACK08];
.GLOBAL         a_VolTrack08;

.VAR/DM/CIRC    a_VolTrack09[LENTRACK09];
.GLOBAL         a_VolTrack09;

.VAR/DM/CIRC    a_VolTrack10[LENTRACK10];
.GLOBAL         a_VolTrack10;

.VAR/DM/CIRC    a_VolTrack11[LENTRACK11];
.GLOBAL         a_VolTrack11;

.VAR/DM/CIRC    a_VolTrack12[LENTRACK12];
.GLOBAL         a_VolTrack12;

.VAR/DM/CIRC    a_VolTrack13[LENTRACK13];
.GLOBAL         a_VolTrack13;

.VAR/DM/CIRC    a_VolTrack14[LENTRACK14];
.GLOBAL         a_VolTrack14;

.VAR/DM/CIRC    a_VolTrack15[LENTRACK15];
.GLOBAL         a_VolTrack15;

.VAR/DM/CIRC    a_VolTrack16[LENTRACK16];
.GLOBAL         a_VolTrack16;

.VAR/DM/CIRC    a_VolTrack17[LENTRACK17];
.GLOBAL         a_VolTrack17;

.VAR/DM/CIRC    a_VolTrack18[LENTRACK18];
.GLOBAL         a_VolTrack18;

.VAR/DM/CIRC    a_VolTrack19[LENTRACK19];
.GLOBAL         a_VolTrack19;

.VAR/DM/CIRC    a_VolTrack20[LENTRACK20];
.GLOBAL         a_VolTrack20;

.VAR/DM/CIRC    a_VolTrack21[LENTRACK21];
.GLOBAL         a_VolTrack21;

.VAR/DM/CIRC    a_VolTrack22[LENTRACK22];
.GLOBAL         a_VolTrack22;

.VAR/DM/CIRC    a_VolTrack23[LENTRACK23];
.GLOBAL         a_VolTrack23;

.VAR/DM/CIRC    a_VolTrack24[LENTRACK24];
.GLOBAL         a_VolTrack24;

.VAR/DM/CIRC    a_VolTrack25[LENTRACK25];
.GLOBAL         a_VolTrack25;

.VAR/DM/CIRC    a_VolTrack26[LENTRACK26];
.GLOBAL         a_VolTrack26;

.VAR/DM/CIRC    a_VolTrack27[LENTRACK27];
.GLOBAL         a_VolTrack27;

.VAR/DM/CIRC    a_VolTrack28[LENTRACK28];
.GLOBAL         a_VolTrack28;

.VAR/DM/CIRC    a_VolTrack29[LENTRACK29];
.GLOBAL         a_VolTrack29;

.VAR/DM/CIRC    a_VolTrack30[LENTRACK30];
.GLOBAL         a_VolTrack30;

.VAR/DM/CIRC    a_VolTrack31[LENTRACK31];
.GLOBAL         a_VolTrack31;

/*
 *  control tracks for track00.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack00[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack00;

.VAR/DM/CIRC    a_CTRLTrack00_0[LENCTRLTRACK00_0];
.GLOBAL         a_CTRLTrack00_0;

.VAR/DM/CIRC    a_CTRLTrack00_1[LENCTRLTRACK00_1];
.GLOBAL         a_CTRLTrack00_1;

.VAR/DM/CIRC    a_CTRLTrack00_2[LENCTRLTRACK00_2];
.GLOBAL         a_CTRLTrack00_2;

.VAR/DM/CIRC    a_CTRLTrack00_3[LENCTRLTRACK00_3];
.GLOBAL         a_CTRLTrack00_3;

.VAR/DM/CIRC    a_CTRLTrack00_4[LENCTRLTRACK00_4];
.GLOBAL         a_CTRLTrack00_4;

.VAR/DM/CIRC    a_CTRLTrack00_5[LENCTRLTRACK00_5];
.GLOBAL         a_CTRLTrack00_5;

.VAR/DM/CIRC    a_CTRLTrack00_6[LENCTRLTRACK00_6];
.GLOBAL         a_CTRLTrack00_6;

.VAR/DM/CIRC    a_CTRLTrack00_7[LENCTRLTRACK00_7];
.GLOBAL         a_CTRLTrack00_7;

/*
 *  control tracks for track00.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack01[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack01;

.VAR/DM/CIRC    a_CTRLTrack01_0[LENCTRLTRACK01_0];
.GLOBAL         a_CTRLTrack01_0;

.VAR/DM/CIRC    a_CTRLTrack01_1[LENCTRLTRACK01_1];
.GLOBAL         a_CTRLTrack01_1;

.VAR/DM/CIRC    a_CTRLTrack01_2[LENCTRLTRACK01_2];
.GLOBAL         a_CTRLTrack01_2;

.VAR/DM/CIRC    a_CTRLTrack01_3[LENCTRLTRACK01_3];
.GLOBAL         a_CTRLTrack01_3;

.VAR/DM/CIRC    a_CTRLTrack01_4[LENCTRLTRACK01_4];
.GLOBAL         a_CTRLTrack01_4;

.VAR/DM/CIRC    a_CTRLTrack01_5[LENCTRLTRACK01_5];
.GLOBAL         a_CTRLTrack01_5;

.VAR/DM/CIRC    a_CTRLTrack01_6[LENCTRLTRACK01_6];
.GLOBAL         a_CTRLTrack01_6;

.VAR/DM/CIRC    a_CTRLTrack01_7[LENCTRLTRACK01_7];
.GLOBAL         a_CTRLTrack01_7;

/*
 *  control tracks for track02.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack02[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack02;

.VAR/DM/CIRC    a_CTRLTrack02_0[LENCTRLTRACK02_0];
.GLOBAL         a_CTRLTrack02_0;

.VAR/DM/CIRC    a_CTRLTrack02_1[LENCTRLTRACK02_1];
.GLOBAL         a_CTRLTrack02_1;

.VAR/DM/CIRC    a_CTRLTrack02_2[LENCTRLTRACK02_2];
.GLOBAL         a_CTRLTrack02_2;

.VAR/DM/CIRC    a_CTRLTrack02_3[LENCTRLTRACK02_3];
.GLOBAL         a_CTRLTrack02_3;

.VAR/DM/CIRC    a_CTRLTrack02_4[LENCTRLTRACK02_4];
.GLOBAL         a_CTRLTrack02_4;

.VAR/DM/CIRC    a_CTRLTrack02_5[LENCTRLTRACK02_5];
.GLOBAL         a_CTRLTrack02_5;

.VAR/DM/CIRC    a_CTRLTrack02_6[LENCTRLTRACK02_6];
.GLOBAL         a_CTRLTrack02_6;

.VAR/DM/CIRC    a_CTRLTrack02_7[LENCTRLTRACK02_7];
.GLOBAL         a_CTRLTrack02_7;

/*
 *  control tracks for track03.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack03[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack03;

.VAR/DM/CIRC    a_CTRLTrack03_0[LENCTRLTRACK03_0];
.GLOBAL         a_CTRLTrack03_0;

.VAR/DM/CIRC    a_CTRLTrack03_1[LENCTRLTRACK03_1];
.GLOBAL         a_CTRLTrack03_1;

.VAR/DM/CIRC    a_CTRLTrack03_2[LENCTRLTRACK03_2];
.GLOBAL         a_CTRLTrack03_2;

.VAR/DM/CIRC    a_CTRLTrack03_3[LENCTRLTRACK03_3];
.GLOBAL         a_CTRLTrack03_3;

.VAR/DM/CIRC    a_CTRLTrack03_4[LENCTRLTRACK03_4];
.GLOBAL         a_CTRLTrack03_4;

.VAR/DM/CIRC    a_CTRLTrack03_5[LENCTRLTRACK03_5];
.GLOBAL         a_CTRLTrack03_5;

.VAR/DM/CIRC    a_CTRLTrack03_6[LENCTRLTRACK03_6];
.GLOBAL         a_CTRLTrack03_6;

.VAR/DM/CIRC    a_CTRLTrack03_7[LENCTRLTRACK03_7];
.GLOBAL         a_CTRLTrack03_7;

/*
 *  control tracks for track04.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack04[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack04;

.VAR/DM/CIRC    a_CTRLTrack04_0[LENCTRLTRACK04_0];
.GLOBAL         a_CTRLTrack04_0;

.VAR/DM/CIRC    a_CTRLTrack04_1[LENCTRLTRACK04_1];
.GLOBAL         a_CTRLTrack04_1;

.VAR/DM/CIRC    a_CTRLTrack04_2[LENCTRLTRACK04_2];
.GLOBAL         a_CTRLTrack04_2;

.VAR/DM/CIRC    a_CTRLTrack04_3[LENCTRLTRACK04_3];
.GLOBAL         a_CTRLTrack04_3;

.VAR/DM/CIRC    a_CTRLTrack04_4[LENCTRLTRACK04_4];
.GLOBAL         a_CTRLTrack04_4;

.VAR/DM/CIRC    a_CTRLTrack04_5[LENCTRLTRACK04_5];
.GLOBAL         a_CTRLTrack04_5;

.VAR/DM/CIRC    a_CTRLTrack04_6[LENCTRLTRACK04_6];
.GLOBAL         a_CTRLTrack04_6;

.VAR/DM/CIRC    a_CTRLTrack04_7[LENCTRLTRACK04_7];
.GLOBAL         a_CTRLTrack04_7;

/*
 *  control tracks for track05.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack05[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack05;

.VAR/DM/CIRC    a_CTRLTrack05_0[LENCTRLTRACK05_0];
.GLOBAL         a_CTRLTrack05_0;

.VAR/DM/CIRC    a_CTRLTrack05_1[LENCTRLTRACK05_1];
.GLOBAL         a_CTRLTrack05_1;

.VAR/DM/CIRC    a_CTRLTrack05_2[LENCTRLTRACK05_2];
.GLOBAL         a_CTRLTrack05_2;

.VAR/DM/CIRC    a_CTRLTrack05_3[LENCTRLTRACK05_3];
.GLOBAL         a_CTRLTrack05_3;

.VAR/DM/CIRC    a_CTRLTrack05_4[LENCTRLTRACK05_4];
.GLOBAL         a_CTRLTrack05_4;

.VAR/DM/CIRC    a_CTRLTrack05_5[LENCTRLTRACK05_5];
.GLOBAL         a_CTRLTrack05_5;

.VAR/DM/CIRC    a_CTRLTrack05_6[LENCTRLTRACK05_6];
.GLOBAL         a_CTRLTrack05_6;

.VAR/DM/CIRC    a_CTRLTrack05_7[LENCTRLTRACK05_7];
.GLOBAL         a_CTRLTrack05_7;

/*
 *  control tracks for track06.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack06[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack06;

.VAR/DM/CIRC    a_CTRLTrack06_0[LENCTRLTRACK06_0];
.GLOBAL         a_CTRLTrack06_0;

.VAR/DM/CIRC    a_CTRLTrack06_1[LENCTRLTRACK06_1];
.GLOBAL         a_CTRLTrack06_1;

.VAR/DM/CIRC    a_CTRLTrack06_2[LENCTRLTRACK06_2];
.GLOBAL         a_CTRLTrack06_2;

.VAR/DM/CIRC    a_CTRLTrack06_3[LENCTRLTRACK06_3];
.GLOBAL         a_CTRLTrack06_3;

.VAR/DM/CIRC    a_CTRLTrack06_4[LENCTRLTRACK06_4];
.GLOBAL         a_CTRLTrack06_4;

.VAR/DM/CIRC    a_CTRLTrack06_5[LENCTRLTRACK06_5];
.GLOBAL         a_CTRLTrack06_5;

.VAR/DM/CIRC    a_CTRLTrack06_6[LENCTRLTRACK06_6];
.GLOBAL         a_CTRLTrack06_6;

.VAR/DM/CIRC    a_CTRLTrack06_7[LENCTRLTRACK06_7];
.GLOBAL         a_CTRLTrack06_7;

/*
 *  control tracks for track07.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack07[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack07;

.VAR/DM/CIRC    a_CTRLTrack07_0[LENCTRLTRACK07_0];
.GLOBAL         a_CTRLTrack07_0;

.VAR/DM/CIRC    a_CTRLTrack07_1[LENCTRLTRACK07_1];
.GLOBAL         a_CTRLTrack07_1;

.VAR/DM/CIRC    a_CTRLTrack07_2[LENCTRLTRACK07_2];
.GLOBAL         a_CTRLTrack07_2;

.VAR/DM/CIRC    a_CTRLTrack07_3[LENCTRLTRACK07_3];
.GLOBAL         a_CTRLTrack07_3;

.VAR/DM/CIRC    a_CTRLTrack07_4[LENCTRLTRACK07_4];
.GLOBAL         a_CTRLTrack07_4;

.VAR/DM/CIRC    a_CTRLTrack07_5[LENCTRLTRACK07_5];
.GLOBAL         a_CTRLTrack07_5;

.VAR/DM/CIRC    a_CTRLTrack07_6[LENCTRLTRACK07_6];
.GLOBAL         a_CTRLTrack07_6;

.VAR/DM/CIRC    a_CTRLTrack07_7[LENCTRLTRACK07_7];
.GLOBAL         a_CTRLTrack07_7;

/*
 *  control tracks for track08.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack08[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack08;

.VAR/DM/CIRC    a_CTRLTrack08_0[LENCTRLTRACK08_0];
.GLOBAL         a_CTRLTrack08_0;

.VAR/DM/CIRC    a_CTRLTrack08_1[LENCTRLTRACK08_1];
.GLOBAL         a_CTRLTrack08_1;

.VAR/DM/CIRC    a_CTRLTrack08_2[LENCTRLTRACK08_2];
.GLOBAL         a_CTRLTrack08_2;

.VAR/DM/CIRC    a_CTRLTrack08_3[LENCTRLTRACK08_3];
.GLOBAL         a_CTRLTrack08_3;

.VAR/DM/CIRC    a_CTRLTrack08_4[LENCTRLTRACK08_4];
.GLOBAL         a_CTRLTrack08_4;

.VAR/DM/CIRC    a_CTRLTrack08_5[LENCTRLTRACK08_5];
.GLOBAL         a_CTRLTrack08_5;

.VAR/DM/CIRC    a_CTRLTrack08_6[LENCTRLTRACK08_6];
.GLOBAL         a_CTRLTrack08_6;

.VAR/DM/CIRC    a_CTRLTrack08_7[LENCTRLTRACK08_7];
.GLOBAL         a_CTRLTrack08_7;

/*
 *  control tracks for track09.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack09[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack09;

.VAR/DM/CIRC    a_CTRLTrack09_0[LENCTRLTRACK09_0];
.GLOBAL         a_CTRLTrack09_0;

.VAR/DM/CIRC    a_CTRLTrack09_1[LENCTRLTRACK09_1];
.GLOBAL         a_CTRLTrack09_1;

.VAR/DM/CIRC    a_CTRLTrack09_2[LENCTRLTRACK09_2];
.GLOBAL         a_CTRLTrack09_2;

.VAR/DM/CIRC    a_CTRLTrack09_3[LENCTRLTRACK09_3];
.GLOBAL         a_CTRLTrack09_3;

.VAR/DM/CIRC    a_CTRLTrack09_4[LENCTRLTRACK09_4];
.GLOBAL         a_CTRLTrack09_4;

.VAR/DM/CIRC    a_CTRLTrack09_5[LENCTRLTRACK09_5];
.GLOBAL         a_CTRLTrack09_5;

.VAR/DM/CIRC    a_CTRLTrack09_6[LENCTRLTRACK09_6];
.GLOBAL         a_CTRLTrack09_6;

.VAR/DM/CIRC    a_CTRLTrack09_7[LENCTRLTRACK09_7];
.GLOBAL         a_CTRLTrack09_7;

/*
 *  control tracks for track10.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack10[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack10;

.VAR/DM/CIRC    a_CTRLTrack10_0[LENCTRLTRACK10_0];
.GLOBAL         a_CTRLTrack10_0;

.VAR/DM/CIRC    a_CTRLTrack10_1[LENCTRLTRACK10_1];
.GLOBAL         a_CTRLTrack10_1;

.VAR/DM/CIRC    a_CTRLTrack10_2[LENCTRLTRACK10_2];
.GLOBAL         a_CTRLTrack10_2;

.VAR/DM/CIRC    a_CTRLTrack10_3[LENCTRLTRACK10_3];
.GLOBAL         a_CTRLTrack10_3;

.VAR/DM/CIRC    a_CTRLTrack10_4[LENCTRLTRACK10_4];
.GLOBAL         a_CTRLTrack10_4;

.VAR/DM/CIRC    a_CTRLTrack10_5[LENCTRLTRACK10_5];
.GLOBAL         a_CTRLTrack10_5;

.VAR/DM/CIRC    a_CTRLTrack10_6[LENCTRLTRACK10_6];
.GLOBAL         a_CTRLTrack10_6;

.VAR/DM/CIRC    a_CTRLTrack10_7[LENCTRLTRACK10_7];
.GLOBAL         a_CTRLTrack10_7;

/*
 *  control tracks for track11.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack11[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack11;

.VAR/DM/CIRC    a_CTRLTrack11_0[LENCTRLTRACK11_0];
.GLOBAL         a_CTRLTrack11_0;

.VAR/DM/CIRC    a_CTRLTrack11_1[LENCTRLTRACK11_1];
.GLOBAL         a_CTRLTrack11_1;

.VAR/DM/CIRC    a_CTRLTrack11_2[LENCTRLTRACK11_2];
.GLOBAL         a_CTRLTrack11_2;

.VAR/DM/CIRC    a_CTRLTrack11_3[LENCTRLTRACK11_3];
.GLOBAL         a_CTRLTrack11_3;

.VAR/DM/CIRC    a_CTRLTrack11_4[LENCTRLTRACK11_4];
.GLOBAL         a_CTRLTrack11_4;

.VAR/DM/CIRC    a_CTRLTrack11_5[LENCTRLTRACK11_5];
.GLOBAL         a_CTRLTrack11_5;

.VAR/DM/CIRC    a_CTRLTrack11_6[LENCTRLTRACK11_6];
.GLOBAL         a_CTRLTrack11_6;

.VAR/DM/CIRC    a_CTRLTrack11_7[LENCTRLTRACK11_7];
.GLOBAL         a_CTRLTrack11_7;

/*
 *  control tracks for track12.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack12[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack12;

.VAR/DM/CIRC    a_CTRLTrack12_0[LENCTRLTRACK12_0];
.GLOBAL         a_CTRLTrack12_0;

.VAR/DM/CIRC    a_CTRLTrack12_1[LENCTRLTRACK12_1];
.GLOBAL         a_CTRLTrack12_1;

.VAR/DM/CIRC    a_CTRLTrack12_2[LENCTRLTRACK12_2];
.GLOBAL         a_CTRLTrack12_2;

.VAR/DM/CIRC    a_CTRLTrack12_3[LENCTRLTRACK12_3];
.GLOBAL         a_CTRLTrack12_3;

.VAR/DM/CIRC    a_CTRLTrack12_4[LENCTRLTRACK12_4];
.GLOBAL         a_CTRLTrack12_4;

.VAR/DM/CIRC    a_CTRLTrack12_5[LENCTRLTRACK12_5];
.GLOBAL         a_CTRLTrack12_5;

.VAR/DM/CIRC    a_CTRLTrack12_6[LENCTRLTRACK12_6];
.GLOBAL         a_CTRLTrack12_6;

.VAR/DM/CIRC    a_CTRLTrack12_7[LENCTRLTRACK12_7];
.GLOBAL         a_CTRLTrack12_7;

/*
 *  control tracks for track13.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack13[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack13;

.VAR/DM/CIRC    a_CTRLTrack13_0[LENCTRLTRACK13_0];
.GLOBAL         a_CTRLTrack13_0;

.VAR/DM/CIRC    a_CTRLTrack13_1[LENCTRLTRACK13_1];
.GLOBAL         a_CTRLTrack13_1;

.VAR/DM/CIRC    a_CTRLTrack13_2[LENCTRLTRACK13_2];
.GLOBAL         a_CTRLTrack13_2;

.VAR/DM/CIRC    a_CTRLTrack13_3[LENCTRLTRACK13_3];
.GLOBAL         a_CTRLTrack13_3;

.VAR/DM/CIRC    a_CTRLTrack13_4[LENCTRLTRACK13_4];
.GLOBAL         a_CTRLTrack13_4;

.VAR/DM/CIRC    a_CTRLTrack13_5[LENCTRLTRACK13_5];
.GLOBAL         a_CTRLTrack13_5;

.VAR/DM/CIRC    a_CTRLTrack13_6[LENCTRLTRACK13_6];
.GLOBAL         a_CTRLTrack13_6;

.VAR/DM/CIRC    a_CTRLTrack13_7[LENCTRLTRACK13_7];
.GLOBAL         a_CTRLTrack13_7;

/*
 *  control tracks for track14.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack14[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack14;

.VAR/DM/CIRC    a_CTRLTrack14_0[LENCTRLTRACK14_0];
.GLOBAL         a_CTRLTrack14_0;

.VAR/DM/CIRC    a_CTRLTrack14_1[LENCTRLTRACK14_1];
.GLOBAL         a_CTRLTrack14_1;

.VAR/DM/CIRC    a_CTRLTrack14_2[LENCTRLTRACK14_2];
.GLOBAL         a_CTRLTrack14_2;

.VAR/DM/CIRC    a_CTRLTrack14_3[LENCTRLTRACK14_3];
.GLOBAL         a_CTRLTrack14_3;

.VAR/DM/CIRC    a_CTRLTrack14_4[LENCTRLTRACK14_4];
.GLOBAL         a_CTRLTrack14_4;

.VAR/DM/CIRC    a_CTRLTrack14_5[LENCTRLTRACK14_5];
.GLOBAL         a_CTRLTrack14_5;

.VAR/DM/CIRC    a_CTRLTrack14_6[LENCTRLTRACK14_6];
.GLOBAL         a_CTRLTrack14_6;

.VAR/DM/CIRC    a_CTRLTrack14_7[LENCTRLTRACK14_7];
.GLOBAL         a_CTRLTrack14_7;

/*
 *  control tracks for track15.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack15[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack15;

.VAR/DM/CIRC    a_CTRLTrack15_0[LENCTRLTRACK15_0];
.GLOBAL         a_CTRLTrack15_0;

.VAR/DM/CIRC    a_CTRLTrack15_1[LENCTRLTRACK15_1];
.GLOBAL         a_CTRLTrack15_1;

.VAR/DM/CIRC    a_CTRLTrack15_2[LENCTRLTRACK15_2];
.GLOBAL         a_CTRLTrack15_2;

.VAR/DM/CIRC    a_CTRLTrack15_3[LENCTRLTRACK15_3];
.GLOBAL         a_CTRLTrack15_3;

.VAR/DM/CIRC    a_CTRLTrack15_4[LENCTRLTRACK15_4];
.GLOBAL         a_CTRLTrack15_4;

.VAR/DM/CIRC    a_CTRLTrack15_5[LENCTRLTRACK15_5];
.GLOBAL         a_CTRLTrack15_5;

.VAR/DM/CIRC    a_CTRLTrack15_6[LENCTRLTRACK15_6];
.GLOBAL         a_CTRLTrack15_6;

.VAR/DM/CIRC    a_CTRLTrack15_7[LENCTRLTRACK15_7];
.GLOBAL         a_CTRLTrack15_7;

/*
 *  control tracks for track16.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack16[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack16;

.VAR/DM/CIRC    a_CTRLTrack16_0[LENCTRLTRACK16_0];
.GLOBAL         a_CTRLTrack16_0;

.VAR/DM/CIRC    a_CTRLTrack16_1[LENCTRLTRACK16_1];
.GLOBAL         a_CTRLTrack16_1;

.VAR/DM/CIRC    a_CTRLTrack16_2[LENCTRLTRACK16_2];
.GLOBAL         a_CTRLTrack16_2;

.VAR/DM/CIRC    a_CTRLTrack16_3[LENCTRLTRACK16_3];
.GLOBAL         a_CTRLTrack16_3;

.VAR/DM/CIRC    a_CTRLTrack16_4[LENCTRLTRACK16_4];
.GLOBAL         a_CTRLTrack16_4;

.VAR/DM/CIRC    a_CTRLTrack16_5[LENCTRLTRACK16_5];
.GLOBAL         a_CTRLTrack16_5;

.VAR/DM/CIRC    a_CTRLTrack16_6[LENCTRLTRACK16_6];
.GLOBAL         a_CTRLTrack16_6;

.VAR/DM/CIRC    a_CTRLTrack16_7[LENCTRLTRACK16_7];
.GLOBAL         a_CTRLTrack16_7;

/*
 *  control tracks for track17.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack17[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack17;

.VAR/DM/CIRC    a_CTRLTrack17_0[LENCTRLTRACK17_0];
.GLOBAL         a_CTRLTrack17_0;

.VAR/DM/CIRC    a_CTRLTrack17_1[LENCTRLTRACK17_1];
.GLOBAL         a_CTRLTrack17_1;

.VAR/DM/CIRC    a_CTRLTrack17_2[LENCTRLTRACK17_2];
.GLOBAL         a_CTRLTrack17_2;

.VAR/DM/CIRC    a_CTRLTrack17_3[LENCTRLTRACK17_3];
.GLOBAL         a_CTRLTrack17_3;

.VAR/DM/CIRC    a_CTRLTrack17_4[LENCTRLTRACK17_4];
.GLOBAL         a_CTRLTrack17_4;

.VAR/DM/CIRC    a_CTRLTrack17_5[LENCTRLTRACK17_5];
.GLOBAL         a_CTRLTrack17_5;

.VAR/DM/CIRC    a_CTRLTrack17_6[LENCTRLTRACK17_6];
.GLOBAL         a_CTRLTrack17_6;

.VAR/DM/CIRC    a_CTRLTrack17_7[LENCTRLTRACK17_7];
.GLOBAL         a_CTRLTrack17_7;

/*
 *  control tracks for track18.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack18[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack18;

.VAR/DM/CIRC    a_CTRLTrack18_0[LENCTRLTRACK18_0];
.GLOBAL         a_CTRLTrack18_0;

.VAR/DM/CIRC    a_CTRLTrack18_1[LENCTRLTRACK18_1];
.GLOBAL         a_CTRLTrack18_1;

.VAR/DM/CIRC    a_CTRLTrack18_2[LENCTRLTRACK18_2];
.GLOBAL         a_CTRLTrack18_2;

.VAR/DM/CIRC    a_CTRLTrack18_3[LENCTRLTRACK18_3];
.GLOBAL         a_CTRLTrack18_3;

.VAR/DM/CIRC    a_CTRLTrack18_4[LENCTRLTRACK18_4];
.GLOBAL         a_CTRLTrack18_4;

.VAR/DM/CIRC    a_CTRLTrack18_5[LENCTRLTRACK18_5];
.GLOBAL         a_CTRLTrack18_5;

.VAR/DM/CIRC    a_CTRLTrack18_6[LENCTRLTRACK18_6];
.GLOBAL         a_CTRLTrack18_6;

.VAR/DM/CIRC    a_CTRLTrack18_7[LENCTRLTRACK18_7];
.GLOBAL         a_CTRLTrack18_7;

/*
 *  control tracks for track19.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack19[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack19;

.VAR/DM/CIRC    a_CTRLTrack19_0[LENCTRLTRACK19_0];
.GLOBAL         a_CTRLTrack19_0;

.VAR/DM/CIRC    a_CTRLTrack19_1[LENCTRLTRACK19_1];
.GLOBAL         a_CTRLTrack19_1;

.VAR/DM/CIRC    a_CTRLTrack19_2[LENCTRLTRACK19_2];
.GLOBAL         a_CTRLTrack19_2;

.VAR/DM/CIRC    a_CTRLTrack19_3[LENCTRLTRACK19_3];
.GLOBAL         a_CTRLTrack19_3;

.VAR/DM/CIRC    a_CTRLTrack19_4[LENCTRLTRACK19_4];
.GLOBAL         a_CTRLTrack19_4;

.VAR/DM/CIRC    a_CTRLTrack19_5[LENCTRLTRACK19_5];
.GLOBAL         a_CTRLTrack19_5;

.VAR/DM/CIRC    a_CTRLTrack19_6[LENCTRLTRACK19_6];
.GLOBAL         a_CTRLTrack19_6;

.VAR/DM/CIRC    a_CTRLTrack19_7[LENCTRLTRACK19_7];
.GLOBAL         a_CTRLTrack19_7;

/*
 *  control tracks for track20.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack20[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack20;

.VAR/DM/CIRC    a_CTRLTrack20_0[LENCTRLTRACK20_0];
.GLOBAL         a_CTRLTrack20_0;

.VAR/DM/CIRC    a_CTRLTrack20_1[LENCTRLTRACK20_1];
.GLOBAL         a_CTRLTrack20_1;

.VAR/DM/CIRC    a_CTRLTrack20_2[LENCTRLTRACK20_2];
.GLOBAL         a_CTRLTrack20_2;

.VAR/DM/CIRC    a_CTRLTrack20_3[LENCTRLTRACK20_3];
.GLOBAL         a_CTRLTrack20_3;

.VAR/DM/CIRC    a_CTRLTrack20_4[LENCTRLTRACK20_4];
.GLOBAL         a_CTRLTrack20_4;

.VAR/DM/CIRC    a_CTRLTrack20_5[LENCTRLTRACK20_5];
.GLOBAL         a_CTRLTrack20_5;

.VAR/DM/CIRC    a_CTRLTrack20_6[LENCTRLTRACK20_6];
.GLOBAL         a_CTRLTrack20_6;

.VAR/DM/CIRC    a_CTRLTrack20_7[LENCTRLTRACK20_7];
.GLOBAL         a_CTRLTrack20_7;

/*
 *  control tracks for track21.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack21[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack21;

.VAR/DM/CIRC    a_CTRLTrack21_0[LENCTRLTRACK21_0];
.GLOBAL         a_CTRLTrack21_0;

.VAR/DM/CIRC    a_CTRLTrack21_1[LENCTRLTRACK21_1];
.GLOBAL         a_CTRLTrack21_1;

.VAR/DM/CIRC    a_CTRLTrack21_2[LENCTRLTRACK21_2];
.GLOBAL         a_CTRLTrack21_2;

.VAR/DM/CIRC    a_CTRLTrack21_3[LENCTRLTRACK21_3];
.GLOBAL         a_CTRLTrack21_3;

.VAR/DM/CIRC    a_CTRLTrack21_4[LENCTRLTRACK21_4];
.GLOBAL         a_CTRLTrack21_4;

.VAR/DM/CIRC    a_CTRLTrack21_5[LENCTRLTRACK21_5];
.GLOBAL         a_CTRLTrack21_5;

.VAR/DM/CIRC    a_CTRLTrack21_6[LENCTRLTRACK21_6];
.GLOBAL         a_CTRLTrack21_6;

.VAR/DM/CIRC    a_CTRLTrack21_7[LENCTRLTRACK21_7];
.GLOBAL         a_CTRLTrack21_7;

/*
 *  control tracks for track22.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack22[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack22;

.VAR/DM/CIRC    a_CTRLTrack22_0[LENCTRLTRACK22_0];
.GLOBAL         a_CTRLTrack22_0;

.VAR/DM/CIRC    a_CTRLTrack22_1[LENCTRLTRACK22_1];
.GLOBAL         a_CTRLTrack22_1;

.VAR/DM/CIRC    a_CTRLTrack22_2[LENCTRLTRACK22_2];
.GLOBAL         a_CTRLTrack22_2;

.VAR/DM/CIRC    a_CTRLTrack22_3[LENCTRLTRACK22_3];
.GLOBAL         a_CTRLTrack22_3;

.VAR/DM/CIRC    a_CTRLTrack22_4[LENCTRLTRACK22_4];
.GLOBAL         a_CTRLTrack22_4;

.VAR/DM/CIRC    a_CTRLTrack22_5[LENCTRLTRACK22_5];
.GLOBAL         a_CTRLTrack22_5;

.VAR/DM/CIRC    a_CTRLTrack22_6[LENCTRLTRACK22_6];
.GLOBAL         a_CTRLTrack22_6;

.VAR/DM/CIRC    a_CTRLTrack22_7[LENCTRLTRACK22_7];
.GLOBAL         a_CTRLTrack22_7;

/*
 *  control tracks for track23.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack23[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack23;

.VAR/DM/CIRC    a_CTRLTrack23_0[LENCTRLTRACK23_0];
.GLOBAL         a_CTRLTrack23_0;

.VAR/DM/CIRC    a_CTRLTrack23_1[LENCTRLTRACK23_1];
.GLOBAL         a_CTRLTrack23_1;

.VAR/DM/CIRC    a_CTRLTrack23_2[LENCTRLTRACK23_2];
.GLOBAL         a_CTRLTrack23_2;

.VAR/DM/CIRC    a_CTRLTrack23_3[LENCTRLTRACK23_3];
.GLOBAL         a_CTRLTrack23_3;

.VAR/DM/CIRC    a_CTRLTrack23_4[LENCTRLTRACK23_4];
.GLOBAL         a_CTRLTrack23_4;

.VAR/DM/CIRC    a_CTRLTrack23_5[LENCTRLTRACK23_5];
.GLOBAL         a_CTRLTrack23_5;

.VAR/DM/CIRC    a_CTRLTrack23_6[LENCTRLTRACK23_6];
.GLOBAL         a_CTRLTrack23_6;

.VAR/DM/CIRC    a_CTRLTrack23_7[LENCTRLTRACK23_7];
.GLOBAL         a_CTRLTrack23_7;

/*
 *  control tracks for track24.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack24[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack24;

.VAR/DM/CIRC    a_CTRLTrack24_0[LENCTRLTRACK24_0];
.GLOBAL         a_CTRLTrack24_0;

.VAR/DM/CIRC    a_CTRLTrack24_1[LENCTRLTRACK24_1];
.GLOBAL         a_CTRLTrack24_1;

.VAR/DM/CIRC    a_CTRLTrack24_2[LENCTRLTRACK24_2];
.GLOBAL         a_CTRLTrack24_2;

.VAR/DM/CIRC    a_CTRLTrack24_3[LENCTRLTRACK24_3];
.GLOBAL         a_CTRLTrack24_3;

.VAR/DM/CIRC    a_CTRLTrack24_4[LENCTRLTRACK24_4];
.GLOBAL         a_CTRLTrack24_4;

.VAR/DM/CIRC    a_CTRLTrack24_5[LENCTRLTRACK24_5];
.GLOBAL         a_CTRLTrack24_5;

.VAR/DM/CIRC    a_CTRLTrack24_6[LENCTRLTRACK24_6];
.GLOBAL         a_CTRLTrack24_6;

.VAR/DM/CIRC    a_CTRLTrack24_7[LENCTRLTRACK24_7];
.GLOBAL         a_CTRLTrack24_7;

/*
 *  control tracks for track25.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack25[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack25;

.VAR/DM/CIRC    a_CTRLTrack25_0[LENCTRLTRACK25_0];
.GLOBAL         a_CTRLTrack25_0;

.VAR/DM/CIRC    a_CTRLTrack25_1[LENCTRLTRACK25_1];
.GLOBAL         a_CTRLTrack25_1;

.VAR/DM/CIRC    a_CTRLTrack25_2[LENCTRLTRACK25_2];
.GLOBAL         a_CTRLTrack25_2;

.VAR/DM/CIRC    a_CTRLTrack25_3[LENCTRLTRACK25_3];
.GLOBAL         a_CTRLTrack25_3;

.VAR/DM/CIRC    a_CTRLTrack25_4[LENCTRLTRACK25_4];
.GLOBAL         a_CTRLTrack25_4;

.VAR/DM/CIRC    a_CTRLTrack25_5[LENCTRLTRACK25_5];
.GLOBAL         a_CTRLTrack25_5;

.VAR/DM/CIRC    a_CTRLTrack25_6[LENCTRLTRACK25_6];
.GLOBAL         a_CTRLTrack25_6;

.VAR/DM/CIRC    a_CTRLTrack25_7[LENCTRLTRACK25_7];
.GLOBAL         a_CTRLTrack25_7;

/*
 *  control tracks for track26.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack26[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack26;

.VAR/DM/CIRC    a_CTRLTrack26_0[LENCTRLTRACK26_0];
.GLOBAL         a_CTRLTrack26_0;

.VAR/DM/CIRC    a_CTRLTrack26_1[LENCTRLTRACK26_1];
.GLOBAL         a_CTRLTrack26_1;

.VAR/DM/CIRC    a_CTRLTrack26_2[LENCTRLTRACK26_2];
.GLOBAL         a_CTRLTrack26_2;

.VAR/DM/CIRC    a_CTRLTrack26_3[LENCTRLTRACK26_3];
.GLOBAL         a_CTRLTrack26_3;

.VAR/DM/CIRC    a_CTRLTrack26_4[LENCTRLTRACK26_4];
.GLOBAL         a_CTRLTrack26_4;

.VAR/DM/CIRC    a_CTRLTrack26_5[LENCTRLTRACK26_5];
.GLOBAL         a_CTRLTrack26_5;

.VAR/DM/CIRC    a_CTRLTrack26_6[LENCTRLTRACK26_6];
.GLOBAL         a_CTRLTrack26_6;

.VAR/DM/CIRC    a_CTRLTrack26_7[LENCTRLTRACK26_7];
.GLOBAL         a_CTRLTrack26_7;

/*
 *  control tracks for track27.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack27[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack27;

.VAR/DM/CIRC    a_CTRLTrack27_0[LENCTRLTRACK27_0];
.GLOBAL         a_CTRLTrack27_0;

.VAR/DM/CIRC    a_CTRLTrack27_1[LENCTRLTRACK27_1];
.GLOBAL         a_CTRLTrack27_1;

.VAR/DM/CIRC    a_CTRLTrack27_2[LENCTRLTRACK27_2];
.GLOBAL         a_CTRLTrack27_2;

.VAR/DM/CIRC    a_CTRLTrack27_3[LENCTRLTRACK27_3];
.GLOBAL         a_CTRLTrack27_3;

.VAR/DM/CIRC    a_CTRLTrack27_4[LENCTRLTRACK27_4];
.GLOBAL         a_CTRLTrack27_4;

.VAR/DM/CIRC    a_CTRLTrack27_5[LENCTRLTRACK27_5];
.GLOBAL         a_CTRLTrack27_5;

.VAR/DM/CIRC    a_CTRLTrack27_6[LENCTRLTRACK27_6];
.GLOBAL         a_CTRLTrack27_6;

.VAR/DM/CIRC    a_CTRLTrack27_7[LENCTRLTRACK27_7];
.GLOBAL         a_CTRLTrack27_7;

/*
 *  control tracks for track28.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack28[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack28;

.VAR/DM/CIRC    a_CTRLTrack28_0[LENCTRLTRACK28_0];
.GLOBAL         a_CTRLTrack28_0;

.VAR/DM/CIRC    a_CTRLTrack28_1[LENCTRLTRACK28_1];
.GLOBAL         a_CTRLTrack28_1;

.VAR/DM/CIRC    a_CTRLTrack28_2[LENCTRLTRACK28_2];
.GLOBAL         a_CTRLTrack28_2;

.VAR/DM/CIRC    a_CTRLTrack28_3[LENCTRLTRACK28_3];
.GLOBAL         a_CTRLTrack28_3;

.VAR/DM/CIRC    a_CTRLTrack28_4[LENCTRLTRACK28_4];
.GLOBAL         a_CTRLTrack28_4;

.VAR/DM/CIRC    a_CTRLTrack28_5[LENCTRLTRACK28_5];
.GLOBAL         a_CTRLTrack28_5;

.VAR/DM/CIRC    a_CTRLTrack28_6[LENCTRLTRACK28_6];
.GLOBAL         a_CTRLTrack28_6;

.VAR/DM/CIRC    a_CTRLTrack28_7[LENCTRLTRACK28_7];
.GLOBAL         a_CTRLTrack28_7;

/*
 *  control tracks for track29.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack29[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack29;

.VAR/DM/CIRC    a_CTRLTrack29_0[LENCTRLTRACK29_0];
.GLOBAL         a_CTRLTrack29_0;

.VAR/DM/CIRC    a_CTRLTrack29_1[LENCTRLTRACK29_1];
.GLOBAL         a_CTRLTrack29_1;

.VAR/DM/CIRC    a_CTRLTrack29_2[LENCTRLTRACK29_2];
.GLOBAL         a_CTRLTrack29_2;

.VAR/DM/CIRC    a_CTRLTrack29_3[LENCTRLTRACK29_3];
.GLOBAL         a_CTRLTrack29_3;

.VAR/DM/CIRC    a_CTRLTrack29_4[LENCTRLTRACK29_4];
.GLOBAL         a_CTRLTrack29_4;

.VAR/DM/CIRC    a_CTRLTrack29_5[LENCTRLTRACK29_5];
.GLOBAL         a_CTRLTrack29_5;

.VAR/DM/CIRC    a_CTRLTrack29_6[LENCTRLTRACK29_6];
.GLOBAL         a_CTRLTrack29_6;

.VAR/DM/CIRC    a_CTRLTrack29_7[LENCTRLTRACK29_7];
.GLOBAL         a_CTRLTrack29_7;

/*
 *  control tracks for track30.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack30[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack30;

.VAR/DM/CIRC    a_CTRLTrack30_0[LENCTRLTRACK30_0];
.GLOBAL         a_CTRLTrack30_0;

.VAR/DM/CIRC    a_CTRLTrack30_1[LENCTRLTRACK30_1];
.GLOBAL         a_CTRLTrack30_1;

.VAR/DM/CIRC    a_CTRLTrack30_2[LENCTRLTRACK30_2];
.GLOBAL         a_CTRLTrack30_2;

.VAR/DM/CIRC    a_CTRLTrack30_3[LENCTRLTRACK30_3];
.GLOBAL         a_CTRLTrack30_3;

.VAR/DM/CIRC    a_CTRLTrack30_4[LENCTRLTRACK30_4];
.GLOBAL         a_CTRLTrack30_4;

.VAR/DM/CIRC    a_CTRLTrack30_5[LENCTRLTRACK30_5];
.GLOBAL         a_CTRLTrack30_5;

.VAR/DM/CIRC    a_CTRLTrack30_6[LENCTRLTRACK30_6];
.GLOBAL         a_CTRLTrack30_6;

.VAR/DM/CIRC    a_CTRLTrack30_7[LENCTRLTRACK30_7];
.GLOBAL         a_CTRLTrack30_7;

/*
 *  control tracks for track31.  should not be modified.
 */

.VAR/DM         ap_CTRLTrack31[1+2*MAXCTRLTRACKS];
.GLOBAL         ap_CTRLTrack31;

.VAR/DM/CIRC    a_CTRLTrack31_0[LENCTRLTRACK31_0];
.GLOBAL         a_CTRLTrack31_0;

.VAR/DM/CIRC    a_CTRLTrack31_1[LENCTRLTRACK31_1];
.GLOBAL         a_CTRLTrack31_1;

.VAR/DM/CIRC    a_CTRLTrack31_2[LENCTRLTRACK31_2];
.GLOBAL         a_CTRLTrack31_2;

.VAR/DM/CIRC    a_CTRLTrack31_3[LENCTRLTRACK31_3];
.GLOBAL         a_CTRLTrack31_3;

.VAR/DM/CIRC    a_CTRLTrack31_4[LENCTRLTRACK31_4];
.GLOBAL         a_CTRLTrack31_4;

.VAR/DM/CIRC    a_CTRLTrack31_5[LENCTRLTRACK31_5];
.GLOBAL         a_CTRLTrack31_5;

.VAR/DM/CIRC    a_CTRLTrack31_6[LENCTRLTRACK31_6];
.GLOBAL         a_CTRLTrack31_6;

.VAR/DM/CIRC    a_CTRLTrack31_7[LENCTRLTRACK31_7];
.GLOBAL         a_CTRLTrack31_7;

/*
 *  karplus-strong buffers.  each music project can define the length of each
 *  buffer here (instead of in GenFXVar.dsp).  do not touch these!
 */

.VAR/DM/CIRC    a_KSBuff0[LENKSBUFF0];
.GLOBAL         a_KSBuff0;

.VAR/DM/CIRC    a_KSBuff1[LENKSBUFF1];
.GLOBAL         a_KSBuff1;

.VAR/DM/CIRC    a_KSBuff2[LENKSBUFF2];
.GLOBAL         a_KSBuff2;

.VAR/DM/CIRC    a_KSBuff3[LENKSBUFF3];
.GLOBAL         a_KSBuff3;

.VAR/DM/CIRC    a_KSBuff4[LENKSBUFF4];
.GLOBAL         a_KSBuff4;

.VAR/DM/CIRC    a_KSBuff5[LENKSBUFF5];
.GLOBAL         a_KSBuff5;

.VAR/DM/CIRC    a_KSBuff6[LENKSBUFF6];
.GLOBAL         a_KSBuff6;

.VAR/DM/CIRC    a_KSBuff7[LENKSBUFF7];
.GLOBAL         a_KSBuff7;

.VAR/PM/CIRC    a_DelayBuff0[LENDSBUFF0];
.GLOBAL         a_DelayBuff0;

.VAR/PM/CIRC    a_DelayBuff1[LENDSBUFF1];
.GLOBAL         a_DelayBuff1;

.ENDMOD;
