/*******************************************************************************
*
*  GetRandomSeed.dsp
*
*  (c) 2002-2004 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
*******************************************************************************/

.MODULE                                     modComVars;

.VAR/DM             b_SeedCaptured;
.GLOBAL             b_SeedCaptured;
.INIT               b_SeedCaptured:         0;

/*
 *  indicates which buffer should be written to SPORT TX.  this value flipflops
 *  inside the RX ISR (when a buffer has been totally emptied).  also note that
 *  the init value of 1 corresponds to the BuffToTX pointer initialization.
 */

.VAR/DM             v_TXBuff0or1;
.GLOBAL             v_TXBuff0or1;
.INIT               v_TXBuff0or1:           1;

/*
 *  used as a semaphore to indicate when it's safe to start writing new data
 *  into an audio buffer.  it is set inside the RX ISR once a TX buffer has
 *  been totally emptied and immediately cleared once the FillAudioBuffer
 *  loop acknowledges it.  if this didn't exist, FillAudioBuffer would run
 *  faster than SPORT TX and data would be corrupted.
 */
 
.VAR/DM             b_FillNewBuffer;
.GLOBAL             b_FillNewBuffer;
.INIT               b_FillNewBuffer:        0;

.VAR/DM             v_AllMute;
.GLOBAL             v_AllMute;
.INIT               v_AllMute:              0;

.VAR/DM             v_NumSongs;
.GLOBAL             v_NumSongs;

.VAR/DM             b_EndSong;
.GLOBAL             b_EndSong;

.ENDMOD;