/******************************************************************************
*
*  ModFuncs.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  fucntions called at krate/control rate.  song control, sequencing, and
*  memory envelopes (MemEnv1, MemEnv3, LFO3).  any additional krate processing
*  can be placed in here.
*
******************************************************************************/

.MODULE                                     modModFuncs_00;

/*
 *  include files for all functions
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "exp1_3.h"

/*
 *  external variables and functions
 */

.EXTERNAL   SongCTRL_00;

/*
 *  entry points
 */
 
.ENTRY      ModFuncs_00;

ModFuncs_00:

/*
 *  everything in here called at control rate.  note that MemEnv1, MemEnv3, and
 *  LFO3 are all automatically called here (the CNTR variables are init'ed in
 *  initialization routines which analyze the number of INIT_ macros for each
 *  of these functions.  do not put extra calls to these functions in the code!
 */

    call SongCTRL_00;
    call Seq2;
    
    CNTR = DM(v_NumMemEnv1);
    do ME1C until CE;
      call MemEnv1;
ME1C: nop;

    CNTR = DM(v_NumMemEnv2);
    do ME2C until CE;
      call MemEnv2;
ME2C: nop;
    
    CNTR = DM(v_NumMemEnv3);
    do ME3C until CE;
      call MemEnv3;
ME3C: nop;

    CNTR = DM(v_NumLFO3);
    do L3C until CE;
      call LFO3;
L3C:  nop;

    rts;
    
.ENDMOD;
