/******************************************************************************
*
*  Bitmask.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
******************************************************************************/

.MODULE                                     mod_Bitmask;

/*
 *  include files
 */



#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"


/*
 *  external variables
 */

.ENTRY      BitmaskFX;

BitmaskFX:
    I2 = DM(p_BitMaskFX);
    AR = DM(I2, M1);
    AY0 = ^Bitmask_JT;
    AR=AR+AY0, AY0=DM(I2, M1);              /* calc offset, get mask */
    I5 = AR;
    jump (I5);

Bitmask_JT:
    jump BitmaskAND;
    jump BitmaskOR;
    jump BitmaskXOR;
    
BitmaskAND:
    SR0 = DM(I7, M6);
    AR=SR0 and AY0, MY0=DM(I2,M1);          /* out (op) mask, get scalar */

    MR=AR*MY0(RND), AY0=MY0;                /* scale for filtered output */
    AY1 = MR1;                              /* save scaled fitlered out */
    
    AX0 = 0x7fff;
    AR = AX0 - AY0;                         /* (1-x) */
    
    MY0 = AR;
    MR = SR0 * MY0 (RND);                    /* (1-x)*out */
    AR = MR1 + AY1;
    DM(I7, M6) = AR;
    DM(p_BitMaskFX) = I2;
    rts;

BitmaskOR:
    SR0 = DM(I7, M6);
    AR=SR0 or AY0, MY0=DM(I2,M1);          /* out (op) mask, get scalar */

    MR=AR*MY0(RND), AY0=MY0;                /* scale for filtered output */
    AY1 = MR1;                              /* save scaled fitlered out */
    
    AX0 = 0x7fff;
    AR = AX0 - AY0;                         /* (1-x) */
    
    MY0 = AR;
    MR = SR0 * MY0 (RND);                    /* (1-x)*out */
    AR = MR1 + AY1;
    DM(I7, M6) = AR;
    DM(p_BitMaskFX) = I2;
    rts;
    
BitmaskXOR:
    SR0 = DM(I7, M6);
    AR=SR0 xor AY0, MY0=DM(I2,M1);          /* out (op) mask, get scalar */
    
    MR=AR*MY0(RND), AY0=MY0;                /* scale for filtered output */
    AY1 = MR1;                              /* save scaled fitlered out */
    
    AX0 = 0x7fff;
    AR = AX0 - AY0;                         /* (1-x) */
    
    MY0 = AR;
    MR = SR0 * MY0 (RND);                    /* (1-x)*out */
    AR = MR1 + AY1;
    DM(I7, M6) = AR;
    DM(p_BitMaskFX) = I2;
    rts;

.ENDMOD;