/******************************************************************************
*
*  Exp1.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
******************************************************************************/

.MODULE                                     modExp1;

/*
 *  include files
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"

/*
 *  entry points
 */

.ENTRY      Exp1Gen;

/*
 *  n+1 = a*n^3 - b*n^2 + c*n^1 - d
 *
 *  refresh
 *  current count
 *  old output
 *  a
 *  b
 *  c
 *  d
 */

Exp1Gen:
    I2 = DM(p_Exp1Gen);
    AY0 = DM(I2, M1);                       /* exp refresh */
    AR = DM(I2, M0);                        /* current count */
    AR = AR + 1;
    DM(I2, M0) = AR;
    NONE = AR - AY0;
    if GT jump CalcNewOutput;
    
    modify(I2, M1);
    AR = DM(I2, M1);                        /* get old output */
    DM(I7, M6) = AR;
    M2 = 4;
    modify(I2, M2);
    DM(p_Exp1Gen) = I2;
    rts;

CalcNewOutput:
    DM(I2, M1) = 0;                         /* reset count */
    AR = DM(I2, M1);                        /* get old output */
    MR = AR * AR (ss);
    MR = MR + AR * AR (ss);
    MR=MR+AR*AR(ss);
    MY0 = DM(I2, M1);                       /* get a */
    MR=MR1*MY0(ss), MY0=DM(I2, M1);         /* get b, a*n^3 */
    AY0 = MR1;
    MR = AR * AR (ss);
    MR=MR+AR*AR(ss);
    MR = MR1 * MY0 (ss);                    /* b+n^2 */
    AF=MR1-AY0, MY0=DM(I2, M1);             /* get c, a+n^3 + b*n^2 */
    MR = AR * MY0 (ss);                     /* c*n^1 */
    AF = MR1 + AF, AX0 = DM(I2, M1);        /* get d */
    AF = AX0 - AF;
    AR = pass AF;
    DM(I7, M6) = AR;                        /* write to output array */
    DM(p_Exp1Gen) = I2;
    M2 = -5;
    modify(I2, M2);
    DM(I2, M0) = AR;
      
    rts;

.ENDMOD;
