/******************************************************************************
*
*  ExpDecay.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
******************************************************************************/

.MODULE                                     modExpDecay;

/*
 *  include files
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"

/*
 *  entry points
 */

.ENTRY      ExpDecayEnv;

ExpDecayEnv:
    I2 = DM(p_ExpDecayEnv);
    I3 = DM(p_GenData);
    AY0 = DM(I2, M1);                       /* get decrate counter */
    AR = DM(I2, M0);                        /* get currdec counter */
    AR = AR + 1;
    DM(I2,M1)=AR, AF=AR-AY0;                /* wr currdec cntr, update env? */
    if LT jump ApplyEnv;

    /* zero currdec counter */    
    M2 = -1;
    modify(I2, M2);
    DM(I2, M1) = 0;
    
    AR = DM(I2, M1);                        /* get scaling multiplier */
    MY0 = DM(I2, M0);                       /* get current scaling amount */
    MR=AR*MY0(SS), MY0=DM(I3,M1);           /* get GenData, update int scalar */
    DM(I2,M1)=MR1, MR=MR1*MY0(SS);          /* wr scalar, scale Gendata */
    
    MY0 = DM(I2, M1);                       /* get global scalar */
    MR=MR1*MY0(SS), AY0=DM(I2,M1);          /* mult w/ global scalar, get pan */
    
    AX0 = 0x7fff;
    AR=AX0-AY0, MY0=MR1;                    /* move scaled out, calc L/R pan */
    MR=AR*MY0(SS), MX0=AY0;                 /* scale LChan, move Rpan */
        
    DM(I4,M7)=MR1, MR=MX0*MY0(SS);          /* save LChan, scale RChan */
    DM(I7, M7) = MR1;                       /* save RChan */
    
    DM(p_ExpDecayEnv) = I2;
    DM(p_GenData) = I3;
    
    rts;
    
ApplyEnv:
    modify(I2, M1);                         /* move ptr to curr scalar */
    AR = DM(I2, M1);
    MY0 = DM(I3, M1);
    MR=AR*MY0(SS), MY0=DM(I2, M1);          /* mult w/ intscal, get glob scal */   
    MR=MR1*MY0(SS), AY0=DM(I2,M1);          /* mult w/ global scalar, get pan */
    
    AX0 = 0x7fff;
    AR=AX0-AY0, MY0=MR1;                    /* move scaled out, calc L/R pan */
    MR=AR*MY0(SS), MX0=AY0;                 /* scale LChan, move Rpan */
        
    DM(I4,M7)=MR1, MR=MX0*MY0(SS);          /* save LChan, scale RChan */
    DM(I7, M7) = MR1;                       /* save RChan */
    
    DM(p_ExpDecayEnv) = I2;
    DM(p_GenData) = I3;
    
    rts;

.ENDMOD;