/******************************************************************************
*
*  Mixer.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
******************************************************************************/

.MODULE                                     modMixer;

/*
 *  include files
 */



#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"


/*
 *  external variables
 */

.ENTRY      LBasicMix;
.ENTRY      RBasicMix;

/*
 *  basic mixing functions.  same procedure for L and R channels.
 *
 *  numtracks=a_Seq2[0];
 *  output=0;
 *  i=0;
 *  while(numtracks!=0) {
 *    output=output+(a_SampOut[i]*a_MixScalar[i]);
 *    a_SampOut[i]=0;
 *    i++;
 *    numtracks--;
 *  }
 */

LBasicMix:
    I2 = ^a_LSampOut;
    I5 = ^a_LMixScalars;
    MR = 0;
    AX0 = 0;
    AR = DM(a_Seq2+0);                  /* a_Seq2+0 init'ed with num tracks */
    AR = AR + 1;
    CNTR = AR;
    do AM1 until CE;
      MX0 = DM(I2, M0);
      MY0 = DM(I5, M7);
AM1:  MR = MR+MX0*MY0(SS), DM(I2, M1)=AX0;

    /* left channel post processing */
    L7 = 0;
    I7 = ^v_LChanOut;
    DM(I7, M6) = MR1;
    
    rts;

RBasicMix:
    I2 = ^a_RSampOut;
    I5 = ^a_RMixScalars;
    MR = 0;
    AX0 = 0;
    AR = DM(a_Seq2+0);                  /* a_Seq2+0 init'ed with num tracks */
    AR = AR + 1;
    CNTR = AR;
    do AM2 until CE;
      MX0 = DM(I2, M0);
      MY0 = DM(I5, M7);
AM2:  MR = MR+MX0*MY0(SS), DM(I2, M1)=AX0;

    /* right channel post processing */
    L7 = 0;
    I7 = ^v_RChanOut;
    DM(I7, M6) = MR1;

    rts;
    
.ENDMOD;
