/******************************************************************************
*
*  PerNoise.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  noise generator with variable modulus
*
*  here's an oddity - modifying the second parameter does change the type of
*  noise.  however, it appears that there are only 16 different "modes" for
*  the pernoise generator.  meaning, LSWs of 0x0000, 0x0010, 0x0020, etc all
*  pretty much sound the same.
*
*  more stuff - feeding even numbers into the third parameter causes no
*  output.  picking numbers like 15, 31, 47, 63, etc cause the most interesting
*  noises with lots of harmonics.
*
******************************************************************************/

.MODULE                                     modPerNoise;

/*
 *  include files
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"

/*
 *  entry points
 */
 
.ENTRY      PerNoiseGen;

PerNoiseGen:
    I2 = DM(p_PerNoiseGen);
    SR1 = DM(I2, M1);                       /* get MSW of seed */
    SR0 = DM(I2, M1);                       /* get LSW of seed */
    MY1 = 25;                               /* MSW of a */
    MY0 = DM(I2, M1);                       /* LSW of a */
    MR = SR0 * MY1 (UU);                    /* a(hi)*x(lo) */
    MR = MR + SR1 * MY0 (UU);               /* a(h)*x(l)+a(l)*x(h) */
    SI = MR1;
    MR1 = MR0;
    MR2 = SI;
    MR0 = 0xfffe;                           /* c=32767, left-shifted by 1 */
    MR = MR + SR0 * MY0 (UU);               /* (above) + a(lo)*x(lo) + c */
    SR = ashift MR2 by 15 (HI);
    SR = SR or lshift MR1 by -1 (HI);       /* right-shift by 1 */
    SR = SR or lshift MR0 by -1 (LO);

    M3 = -3;
    modify(I2, M3);

    DM(I2, M1) = SR1;                       /* save new MSW of seed */
    DM(I2, M1) = SR0;                       /* save new LSW of seed */
    modify(I2, M1);

    DM(p_PerNoiseGen) = I2;
    
    DM(I7, M6) = SR0;                       /* write to output array */

    rts;
        
.ENDMOD;
