/******************************************************************************
*
*  SVF.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  based on original source by shifty
*
******************************************************************************/

.MODULE                                     modSVF;

/*
 *  include files
 */
 

#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"

/*
 *  entry points
 */

.ENTRY      SVFFX;

SVFFX:
    ena M_MODE;
    I2 = DM(p_SVFFX);
    I3 = DM(p_SVFFiltOut);
    MR=0, MX0=DM(I2,M1);              /* get K2 */
    MR1 = DM(I7, M6);                 /* get input */
    MY1 = DM(I3, M1);                 /* MY1 = band */
    MR=MR-MX0*MY1(ss), MY0=DM(I3,M1); /* K2 * band, get low */
    if mv sat mr;
    mx0 = 0x7fff;
    mr  = mr + mx0*my0(ss);           /* calc high */
    if mv sat mr;
    DM(I3, M0) = MR1;                 /* write high */
    M2 = -2;

/*
 *  $B=  $B   + $K3*$H;
 */
 
    MR=0, MX0=DM(I2,M1);              /* K3 */
    MR1 = MY1;                        /* get band */
    MY0 = DM(I3, M2);                 /* get high */
    mr  = mr + mx0*my0(ss);           /* K3 * high */
    if mv sat mr;
    DM(I3, M1) = MR1;                 /* write band */

/*
 *  $L=  $L   - $K4*$B;
 */
 
    MR=0, MX0=DM(I2,M1);              /* K4 */
    M2 = -1;
    MR1 = DM(I3, M2);                 /* get low */
    MY0 = DM(I3, M1);                 /* get band */
    mr  = mr - mx0*my0(ss);
    if mv sat mr;
    DM(I3, M1) = MR1;                 /* write low */

/*
 *  $N=($H+$L)/2;
 */
 
    MY0 = DM(I3, M1);                 /* get high */
    MY1 = MR1;                        /* get low */
    mx0 = 0x3fff;
    mr  = mx0*my0(ss);
    mr  = mr + mx0*my1(ss);
    DM(I3, M1) = MR1;                 /* write notch */
    
    M2 = -4;
    modify(I3, M2);
    AR = DM(I2, M1);
    I5 = ^SVFOutJT;
    M4 = AR;
    modify(I5, M4);
    jump (I5);

SVFOutJT:
    jump SVFBandOut;
    jump SVFLowOut;
    jump SVFHighOut;
    jump SVFNotchOut;

SVFBandOut:
    AR = DM(I3, M0);
    DM(I7, M6) = AR;
    M2 = 4;
    jump ExitSVF;
      
SVFLowOut:
    modify(I3, M1);
    AR = DM(I3, M0);
    DM(I7, M6) = AR;
    M2 = 3;
    jump ExitSVF;
      
SVFHighOut:
    M2 = 2;
    modify(I3, M2);
    AR = DM(I3, M0);
    DM(I7, M6) = AR;
    jump ExitSVF;
      
SVFNotchOut:
    M2 = 3;
    modify(I3, M2);
    AR = DM(I3, M0);
    DM(I7, M6) = AR;
    M2 = 1;
    jump ExitSVF;

ExitSVF:
    dis M_MODE;
    modify(I3, M2);
    DM(p_SVFFiltOut) = I3;
    DM(p_SVFFX) = I2;
      
    rts;
    
.ENDMOD;
