/*****************************************************************************
*
*  ExpSyn1.dsp
*
*****************************************************************************/

.MODULE                                     modExpSyn1;

/*
 *  include files
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"

/*
 *  entry point
 */

.ENTRY      ExpSyn1Gen;

/*
 *  variables for ExpSyn1:
 *
 *  - current zone (0/1)
 *  - decay rate zone 1
 *  - current decay zone 1
 *  - decay min zone 1
 *  - decay rate zone 2
 *  - current decay zone 2
 *  - decay min zone 2
 */


/*----------------------------------------------------------------------------*/
/*----------------------------------ExpSyn1-----------------------------------*/
/*----------------------------------------------------------------------------*/

#define     EXPSYN1GEN_CALLS            5
#define     EXPSYN1GEN_VARS             7
                                        
#define     EXPSYN1GEN_ZONE             0
#define     EXPSYN1GEN_DR1              1
#define     EXPSYN1GEN_CURRDECZ1        2
#define     EXPSYN1GEN_DECMIN1          3
#define     EXPSYN1GEN_DR2              4
#define     EXPSYN1GEN_CURRDECZ2        5
#define     EXPSYN1GEN_DECMIN2          6

#define     INIT_EXPSYN1GEN(zone, dr1, currdecz1, decmin1, dr2, currdecz2, decmin2) \
    DM(I2, M1) = zone; \
    DM(I2, M1) = dr1; \
    DM(I2, M1) = currdecz1; \
    DM(I2, M1) = decmin1; \
    DM(I2, M1) = dr2; \
    DM(I2, M1) = currdecz2; \
    DM(I2, M1) = decmin2


/******************************************************************************
*
*  an exponential synthesizer
*
*  - current zone (0/1)
*  - decay rate zone 1
*  - current decay zone 1
*  - decay min zone 1
*  - decay rate zone 2
*  - current decay zone 2
*  - decay min zone 2
*
*******************************************************************************/

.VAR/DM         a_ExpSyn1Gen[EXPSYN1GEN_VARS*EXPSYN1GEN_CALLS];
.GLOBAL         a_ExpSyn1Gen;
                
.VAR/DM         p_ExpSyn1Gen;
.GLOBAL         p_ExpSyn1Gen;

ExpSyn1Gen:
    I2 = DM(p_ExpSyn1Gen);
    I3 = I2;
    AR = DM(I2, M1);                       /* get curr zone */
    AR = pass AR;
    if NE jump ESZone2;

ESZone1:
    MX0 = DM(I2, M1);                       /* decay rate */
    MY0 = DM(I2, M0);                       /* current decay */
    MR = MX0 * MY0 (ss);                    /* calc new decay */
    DM(I2, M1) = MR1;                       /* save new decay */
    AY0 = DM(I2, M1);
    AR=MR1-AY0, DM(I7,M6)=MR1;              /* write to out array,curr-thresh */
    if GT jump StillZone1;
    DM(I3, M1) = 1;                         /* if below thresh, now zone 2 */
    modify(I3, M1);
    DM(I3, M1) = 0x7fff;                    /* reset curr decay 1 */

StillZone1:
    M2 = 3;
    modify(I2, M2);
    DM(p_ExpSyn1Gen) = I2;
    rts;

ESZone2:
    M2 = 3;
    modify(I2, M2);                         /* move ptr to zone 2 */
    MX0 = DM(I2, M1);                       /* decay rate */
    MY0 = DM(I2, M0);                       /* current decay */
    MR = MX0 * MY0 (ss);                    /* calc new decay */
    AR = MR1 - 0x7fff;                      /* curr-1 */
    DM(I2, M1) = MR1;                       /* save new decay */
    !DM(I7, M6) = AR;                        /* write to output array */
    AY0 = DM(I2, M1);
    AF=MR1-AY0, DM(I7,M6)=AR;              /* write to out array,curr-thresh */
    if GT jump StillZone2;
    M2 = 5;
    DM(I3, M2) = 0;                         /* if below thresh, now zone 1 */
    DM(I3, M0) = 0x7fff;                    /* reset curr decay 1 */

StillZone2:
    !M2 = 3;
    
    !modify(I2, M2);
    DM(p_ExpSyn1Gen) = I2;
    rts;


.ENDMOD;