/******************************************************************************
*
*  TrigKS4.dsp
*  
*  generative music trigger for starting KS generator
*
******************************************************************************/

.MODULE                                     modTrigKS4_29;

/*
 *  include files for all functions
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "new29.h"

/*
 *  external variables and functions
 */

.EXTERNAL   v_TrigKS4_29;
.EXTERNAL   v_KSPeriod4_29;
.EXTERNAL   a_KSBuff4;
.EXTERNAL   v_KS4Count_29;
.EXTERNAL   v_KSMask4_29;
.EXTERNAL   a_KSGen;
.EXTERNAL   v_BaseScalarKS4_29;
!.EXTERNAL   a_Scalar;

/*
 *  entry points
 */
 
.ENTRY      TrigKS4_29;

TrigKS4_29:
    AR = DM(v_TrigKS4_29);
    AR = AR + 1;
    DM(v_TrigKS4_29) = AR;
    AY0 = DM(v_KSPeriod4_29);
    AR = AR - AY0;
    if LT rts;

InitKS4:
    DM(v_TrigKS4_29) = M0;

    AR = DM(v_KS4Count_29);
    AR = AR - 1;
    DM(v_KS4Count_29) = AR;
    if LE jump NewKS4Count;
    
    call FillKS4Buff;

    /* pan ks3 */
    AR = DM(I6, M7);
    AY0 = 0x5ff;
    AF = tstbit 0 of AR;
    if EQ jump LeftPanKS4;

RightPanKS4:
    AR = AR and AY0;
    AR = AR + 0x4000;
    DM(a_ADSRPanEnv + ((5*ADSRPANENV_VARS)+ADSRPANENV_PAN)) = AR;
    jump ModKS4Freq;

LeftPanKS4:
    AF = AR and AY0;
    AX0 = 0x4000;
    AR = AX0 - AF;
    DM(a_ADSRPanEnv + ((5*ADSRPANENV_VARS)+ADSRPANENV_PAN)) = AR;

ModKS4Freq:
    AR = DM(a_KSGen+(3*KSGEN_VARS)+KSGEN_FREQ);
    AR = AR + 16;
    DM(a_KSGen+(3*KSGEN_VARS)+KSGEN_FREQ) = AR;

    AR = DM(a_GenSHFX+(3*GENSHFX_VARS)+GENSHFX_HOLDPER);
    AR = AR + 1;
    DM(a_GenSHFX+(3*GENSHFX_VARS)+GENSHFX_HOLDPER) = AR;

NoScaleInc:
    AR = DM(I6, M7);
    AR = AR and 1;
    DM(a_KSGen+(3*KSGEN_VARS)+KSGEN_ADDSUB) = AR;

    AR = DM(I6, M7);
    AY0 = DM(v_KSMask4_29);
    AF = AR and AY0;
    AR = tstbit 4 of AR;
    AX0 = DM(a_KSGen+(3*KSGEN_VARS)+KSGEN_AVEFACSIGN);
    if EQ jump AddRand4;

SubRand4:
    AR = AX0 - AF;
    jump WriteKS4;
    
AddRand4:
    AR = AX0 + AF;
WriteKS4:
    DM(a_KSGen+(3*KSGEN_VARS)+KSGEN_AVEFACSIGN) = AR;
    
    rts;

NewKS4Count:
    AR = 10;
    DM(a_GenSHFX+(3*GENSHFX_VARS)+GENSHFX_HOLDPER) = AR;

    AR = DM(v_BaseScalarKS4_29);
    DM(a_ADSRPanEnv+(5*ADSRPANENV_VARS)+ADSRPANENV_SCALAR) = AR;
    
    AR = DM(I6, M7);
    MY0 = 6;
    MR = AR * MY0 (SS);
    DM(v_KS4Count_29) = MR1;
    
    AR = 0x5f;
    DM(a_KSGen+(3*KSGEN_VARS)+KSGEN_FREQ) = AR;
    
    rts;

.ENDMOD;
