/******************************************************************************
*
*  SongCTRL.dsp
*  
*  generative music control function
*
******************************************************************************/

.MODULE                                     modSongCTRL_29;

/*
 *  include files for all functions
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "new29.h"

/*
 *  external variables and functions
 */

#if 0
.EXTERNAL   v_SongCTRLPeriod;
.EXTERNAL   v_SongCTRL1;
.EXTERNAL   v_DelayCNTR;
.EXTERNAL   v_KSMask1_29;
.EXTERNAL   v_KSMask2_29;
.EXTERNAL   v_KSMask3_29;
.EXTERNAL   v_KSMask4_29;
.EXTERNAL   v_OCMask1_29;
.EXTERNAL   v_OCMask2_29;
.EXTERNAL   v_OCMask3_29;
.EXTERNAL   v_RotMask2_29;
.EXTERNAL   a_TrigTrack00;
.EXTERNAL   a_TrigTrack01;
.EXTERNAL   a_TrigTrack03;
.EXTERNAL   a_TrigTrack02;
.EXTERNAL   a_TrigTrack04;
.EXTERNAL   a_TrigTrack05;
.EXTERNAL   a_TrigTrack06;
.EXTERNAL   a_TrigTrack12;
.EXTERNAL   a_TrigTrack13;
.EXTERNAL   a_TrigTrack14;
.EXTERNAL   a_TrigTrack15;
.EXTERNAL   v_ProbModOC2_29;
.EXTERNAL   v_BaseScalarKS3_29;
.EXTERNAL   v_BaseScalarKS4_29;
.EXTERNAL   v_SongCNTR_29;
.EXTERNAL   a_LFO;
.EXTERNAL   a_SimpSeq;
#endif
/*
 *  entry points
 */

.ENTRY      SongCTRL_29;
.ENTRY      Measure_JT;
.ENTRY      EndMeasure_JT;

SongCTRL_29:
Measure_JT:
EndMeasure_JT:
#if 0
    AR = DM(v_SongCTRLPeriod);
    AR = AR + 1;
    DM(v_SongCTRLPeriod) = AR;
    AY0 = SONGCTRLPERIOD_29;
    AR = AR - AY0;
    if LT rts;
    
    DM(v_SongCTRLPeriod) = M0;

/*
 *  bd + snares on 2/4
 */

!jump CTRL9;

CTRL1:
    AR = DM(v_SongCTRL1);
    AR = tstbit 0 of AR;
    if NE jump CTRL2;
    
    AR = DM(v_DelayCNTR);
    AR = AR + 1;
    DM(v_DelayCNTR) = AR;
    AY0 = 6;
    AR = AR - AY0;
    if LT rts;
    
    DM(v_DelayCNTR) = M0;
    
    AR = DM(v_SongCTRL1);
    AR = setbit 0 of AR;
    DM(v_SongCTRL1) = AR;
    rts;

/*
 *  fast repeating KS
 */
    
CTRL2:
    AR = DM(v_SongCTRL1);
    AR = tstbit 1 of AR;
    if NE jump CTRL3;

    AR = DM(a_Scalar + 5);
    AY0 = 0x0060;
    AR = AR + AY0;
    DM(a_Scalar + 5) = AR;
    DM(v_BaseScalarKS3_29) = AR;

    AR = DM(a_Scalar + 4);
    AY0 = 0x0100;
    AR = AR + AY0;
    DM(a_Scalar + 4) = AR;
    DM(v_BaseScalarKS4_29) = AR;
    AY0 = 0x0800;
    NONE = AR - AY0;
    if LT rts;

    AR = DM(v_SongCTRL1);
    AR = setbit 1 of AR;
    DM(v_SongCTRL1) = AR;
    rts;

/*
 *  low triangles
 */

CTRL3:
    AR = DM(v_SongCTRL1);
    AR = tstbit 2 of AR;
    if NE jump CTRL4;

    AR = DM(a_Scalar + 0);
    AY0 = 0x0080;
    AR = AR + AY0;
    DM(a_Scalar + 0) = AR;

    AR = DM(a_Scalar + 1);
    AR = AR + AY0;
    DM(a_Scalar + 1) = AR;
    AY0 = 0x0400;
    NONE = AR - AY0;
    if LT rts;
    
    AR = DM(v_SongCTRL1);
    AR = setbit 2 of AR;
    DM(v_SongCTRL1) = AR;
    rts;
    
CTRL4:
    AR = DM(v_SongCTRL1);
    AR = tstbit 3 of AR;
    if NE jump CTRL5;

    AR = DM(v_DelayCNTR);
    AR = AR + 1;
    DM(v_DelayCNTR) = AR;
    AY0 = 4;
    AR = AR - AY0;
    if LT rts;
    
    DM(v_DelayCNTR) = M0;
    
    AR = DM(v_SongCTRL1);
    AR = setbit 3 of AR;
    DM(v_SongCTRL1) = AR;
    rts;

/*
 *  osc comb on triangles, inc residual bd bass
 */
    
CTRL5:
    AR = DM(v_SongCTRL1);
    AR = tstbit 4 of AR;
    if NE jump CTRL6;

    AR = DM(a_Scalar + 3);
    AY0 = 0x20;
    AR = AR + AY0;
    DM(a_Scalar + 3) = AR;

    AR = DM(a_Scalar + 2);
    AY0 = 0x280;
    AR = AR + AY0;
    DM(a_Scalar + 2) = AR;
    AY0 = 0x1400;
    NONE = AR - AY0;
    if LE rts;

    AR = DM(v_SongCTRL1);
    AR = setbit 4 of AR;
    DM(v_SongCTRL1) = AR;
    rts;

/*
 *  first rotsynth, high pitched
 */

CTRL6:
    AR = DM(v_SongCTRL1);
    AR = tstbit 5 of AR;
    if NE jump CTRL7;    

    I2 = ^a_TrigTrack04 + 64;
    I3 = ^a_TrigTrack12 + 64;
    CNTR = 64;
    AY0 = 0x00a0;
    do V1 until CE;
      AR = DM(I2, M0);
      AR = AR + AY0;
      DM(I3, M1) = AR;
V1:   DM(I2, M1) = AR;   

    AY0 = 0x0500;
    NONE = AR - AY0;
    if LT rts;

    AR = DM(v_SongCTRL1);
    AR = setbit 5 of AR;
    DM(v_SongCTRL1) = AR;
    rts;    

/*
 *  more bd, ks.  introduce rot2.
 */

CTRL7:
    AR = DM(v_SongCTRL1);
    AR = tstbit 6 of AR;
    if NE jump CTRL8;

    AR = 50;
    DM(a_TrigTrack00 + 2) = AR;
    DM(a_TrigTrack00 + 10) = AR;
    DM(a_TrigTrack00 + 34) = AR;
    DM(a_TrigTrack00 + 42) = AR;
    
    AR = 25;
    DM(a_TrigTrack00 + 22) = AR;
    DM(a_TrigTrack00 + 30) = AR;
    DM(a_TrigTrack00 + 54) = AR;
    DM(a_TrigTrack00 + 62) = AR;
    
    AR = 0x1800;
    DM(a_TrigTrack00 + 66) = AR;
    DM(a_TrigTrack00 + 74) = AR;
    DM(a_TrigTrack00 + 98) = AR;
    DM(a_TrigTrack00 + 106) = AR;
    
    DM(a_TrigTrack00 + 86) = AR;
    DM(a_TrigTrack00 + 94) = AR;
    DM(a_TrigTrack00 + 118) = AR;
    DM(a_TrigTrack00 + 126) = AR;

    AR = 100;
    DM(a_TrigTrack03 + 6) = AR;
    DM(a_TrigTrack03 + 14) = AR;
    DM(a_TrigTrack03 + 22) = AR;
    DM(a_TrigTrack03 + 30) = AR;
    
    AR = 0x1400;
    DM(a_TrigTrack03 + 70) = AR;
    DM(a_TrigTrack03 + 78) = AR;
    DM(a_TrigTrack03 + 86) = AR;
    DM(a_TrigTrack03 + 94) = AR;

    I2 = ^a_TrigTrack05 + 64;
    I3 = ^a_TrigTrack13 + 64;
    CNTR = 64;
    AY0 = 0x00a0;
    do V2 until CE;
      AR = DM(I2, M0);
      AR = AR + AY0;
      DM(I3, M1) = AR;
V2:   DM(I2, M1) = AR;   

    AY0 = 0x0500;
    NONE = AR - AY0;
    if LT rts;

    AR = DM(v_SongCTRL1);
    AR = setbit 6 of AR;
    DM(v_SongCTRL1) = AR;
    rts;

/*
 *  pan rot1, rot2.  introduce osccomb4.
 */
    
CTRL8:
    AR = DM(v_SongCTRL1);
    AR = tstbit 7 of AR;
    if NE jump CTRL9;

    AR = DM(a_ADSRPan + ((4*ADSRPANVARS)+ADSR_PAN));
    AR = AR + 0x200;
    DM(a_ADSRPan + ((4*ADSRPANVARS)+ADSR_PAN)) = AR;
    
    AR = DM(a_ADSRPan + ((5*ADSRPANVARS)+ADSR_PAN));
    AR = AR - 0x200;
    DM(a_ADSRPan + ((5*ADSRPANVARS)+ADSR_PAN)) = AR;
    
    AR = DM(a_ADSRPan + ((7*ADSRPANVARS)+ADSR_PAN));
    AR = AR + 0x200;
    DM(a_ADSRPan + ((7*ADSRPANVARS)+ADSR_PAN)) = AR;
    
    AR = DM(a_ADSRPan + ((8*ADSRPANVARS)+ADSR_PAN));
    AR = AR - 0x200;
    DM(a_ADSRPan + ((8*ADSRPANVARS)+ADSR_PAN)) = AR;

    I2 = ^a_TrigTrack06 + 64;
    CNTR = 64;
    AY0 = 0x0300;
    do V3 until CE;
      AR = DM(I2, M0);
      AR = AR + AY0;
V3:   DM(I2, M1) = AR;  

    AY0 = 0x1800;
    NONE = AR - AY0;
    if LT rts;

    AR = DM(v_SongCTRL1);
    AR = setbit 7 of AR;
    DM(v_SongCTRL1) = AR;
    rts;

/*
 *  bring in osccomb3
 */

CTRL9:
    AR = DM(v_SongCTRL1);
    AR = tstbit 8 of AR;
    if NE jump CTRL10;

    AR = 100;
    DM(v_ProbModOC2_29) = AR;

    I3 = ^a_TrigTrack14 + 64;
    I2 = ^a_TrigTrack15 + 64;
    CNTR = 64;
    AY0 = 0x00a0;
    do V10 until CE;
      AR = DM(I3, M0);
      AR = AR + AY0;
      DM(I2, M1) = AR;
V10:  DM(I3, M1) = AR;
  
    AY0 = 0x0500;
    NONE = AR - AY0;
    if LT rts;

    AR = DM(v_SongCTRL1);
    AR = setbit 8 of AR;
    DM(v_SongCTRL1) = AR;
    rts;

/*
 *  inc lofi osccomb and osccomb4
 */

CTRL10:
    AR = DM(v_SongCTRL1);
    AR = tstbit 9 of AR;
    if NE jump CTRL11;

    AR = 0x480;
    DM(a_Scalar + 3) = AR;

    AR = DM(a_ADSRPan + ((9*ADSRPANVARS)+ADSR_PAN));
    AR = AR + 0x100;
    DM(a_ADSRPan + ((9*ADSRPANVARS)+ADSR_PAN)) = AR;
    
    AR = DM(a_ADSRPan + ((10*ADSRPANVARS)+ADSR_PAN));
    AR = AR - 0x100;
    DM(a_ADSRPan + ((10*ADSRPANVARS)+ADSR_PAN)) = AR;
    
    I2 = ^a_TrigTrack06 + 64;
    CNTR = 64;
    AY0 = 0x0080;
    do NV1 until CE;
      AR = DM(I2, M0);
      AR = AR + AY0;
NV1:  DM(I2, M1) = AR;  

    AY0 = 0x2000;
    NONE = AR - AY0;
    if LT rts;

    AR = DM(v_SongCTRL1);
    AR = setbit 9 of AR;
    DM(v_SongCTRL1) = AR;
    rts;

/*
 *  more lofiosccomb, add enw freq to lead.
 */

CTRL11:
    AR = DM(v_SongCTRL1);
    AR = tstbit 10 of AR;
    if NE jump CTRL12;

    AR = 0x580;
    DM(a_Scalar + 3) = AR;
    
    AR = 40;
    DM(a_LFO + (6*LFOVARS)+4) = AR;
    DM(a_LFO + (7*LFOVARS)+4) = AR;
    AR = 10;
    DM(a_LFO + (6*LFOVARS)+3) = AR;
    DM(a_LFO + (7*LFOVARS)+3) = AR;
    
    AR = 500;
    DM(a_LFO + (6*LFOVARS)+1) = AR;
    DM(a_LFO + (7*LFOVARS)+1) = AR;

    AR = DM(v_DelayCNTR);
    AR = AR + 1;
    DM(v_DelayCNTR) = AR;
    AY0 = 8;
    AR = AR - AY0;
    if LT rts;
    
    DM(v_DelayCNTR) = M0;

    AR = DM(v_SongCTRL1);
    AR = setbit 10 of AR;
    DM(v_SongCTRL1) = AR;
    rts;

/*
 *  distort ks1, inc lofifmmod
 */

CTRL12:
    AR = DM(v_SongCTRL1);
    AR = tstbit 11 of AR;
    if NE jump CTRL13;    

    AR = DM(a_Scalar + 3);
    AR = AR + 0x10;
    DM(a_Scalar + 3) = AR;
    
    AR = DM(a_KSGen + 2);
    AR = AR - 2;
    AY0 = 0x10;
    NONE = AR - AY0;
    if LE AR = pass AY0;
    DM(a_KSGen + 2) = AR;

    AR = DM(a_KSGen + 4);
    AY0 = 0x0060;
    AR = AR + AY0;
    DM(a_KSGen + 4) = AR;
    AY0 = 0x6000;
    NONE = AR - AY0;
    if LE rts;

    AR = DM(v_SongCTRL1);
    AR = setbit 11 of AR;
    DM(v_SongCTRL1) = AR;
    rts;

CTRL13:
    AR = DM(v_SongCTRL1);
    AR = tstbit 12 of AR;
    if NE jump CTRL14;
    
    DM(a_Scalar + 0) = M0;
    DM(a_Scalar + 1) = M0;
    DM(a_Scalar + 4) = M0;
    DM(a_Scalar + 5) = M0;
    
    I2 = ^a_TrigTrack00 + 64;
    I3 = ^a_TrigTrack02 + 64;
    CNTR = 64;
    do V4 until CE;
      DM(I3, M1) = 0;
V4:   DM(I2, M1) = 0;

    AR = 100;
    DM(a_TrigTrack03 + 4) = AR;
    DM(a_TrigTrack03 + 12) = AR;
    DM(a_TrigTrack03 + 20) = AR;
    DM(a_TrigTrack03 + 28) = AR;
    
    AR = 0x0800;
    DM(a_TrigTrack03 + 68) = AR;
    DM(a_TrigTrack03 + 76) = AR;
    DM(a_TrigTrack03 + 84) = AR;
    DM(a_TrigTrack03 + 92) = AR;

    AR = DM(v_DelayCNTR);
    AR = AR + 1;
    DM(v_DelayCNTR) = AR;
    AY0 = 4;
    AR = AR - AY0;
    if LT rts;
    
    DM(v_DelayCNTR) = M0;
    
    AR = DM(v_SongCTRL1);
    AR = setbit 12 of AR;
    DM(v_SongCTRL1) = AR;
    rts;
    
CTRL14:
    AR = DM(v_SongCTRL1);
    AR = tstbit 13 of AR;
    if NE jump CTRL15;

    I2 = ^a_TrigTrack00 + 64;
    AR = 0x4000;
    CNTR = 64;
    do A1 until CE;
      DM(I2, M1) = AR;
A1:   AR = AR - 0x80;
      
    I2 = ^a_TrigTrack02 + 64;
    AR = 0x3000;
    CNTR = 64;
    do A2 until CE;
      DM(I2, M1) = AR;
A2:   AR = AR - 0x40;

    I2 = ^a_TrigTrack00;
    M2 = 6;
    AY0 = 100;
    CNTR = 10;
    do A3 until CE;
A3:   DM(I2, M2) = AY0;

    I2 = ^a_TrigTrack02;
    M2 = 4;
    AY0 = 100;
    CNTR = 13;
    do A4 until CE;
A4:   DM(I2, M2) = AY0;

    AR = DM(v_DelayCNTR);
    AR = AR + 1;
    DM(v_DelayCNTR) = AR;
    AY0 = 6;
    AR = AR - AY0;
    if LT rts;
    
    DM(v_DelayCNTR) = M0;

    AR = DM(v_SongCTRL1);
    AR = setbit 13 of AR;
    DM(v_SongCTRL1) = AR;
    rts;

CTRL15:
    AR = DM(v_SongCTRL1);
    AR = tstbit 14 of AR;
    if NE jump CTRL16;
    
    DM(a_Scalar + 2) = M0;
    DM(a_Scalar + 6) = M0;
    DM(v_BaseScalarKS3_29) = M0;
    DM(v_BaseScalarKS4_29) = M0;

    I2 = ^a_TrigTrack00 + 64;
    I3 = ^a_TrigTrack02 + 64;
    CNTR = 64;
    do V8 until CE;
      DM(I3, M1) = 0;
V8:   DM(I2, M1) = 0;

    I2 = ^a_TrigTrack01 + 64;
    I3 = ^a_TrigTrack03 + 64;
    AY0 = 0x0400;
    AY1 = 0x0340;
    CNTR = 32;
    do V6 until CE;
      AR = DM(I2, M0);
      AR = AR - AY0;
      if LE AR = pass 0;
      DM(I2, M1) = AR;
      AR = DM(I3, M0);
      AR = AR - AY1;
      if LE AR = pass 0;
V6:   DM(I3, M1) = AR;

    I2 = ^a_TrigTrack06 + 64;
    CNTR = 64;
    do V7 until CE;
V7:   DM(I2, M1) = 0;

    AR = 0;
    I2 = ^a_TrigTrack01 + 64;
    I3 = ^a_TrigTrack03 + 64;
    CNTR = 64;
    do FC until CE;
      AY0 = DM(I2, M1);
      AR = AR + AY0;
      AY0 = DM(I3, M1);
FC:   AR = AR + AY0;

    if NE rts;
    
    AR = DM(v_SongCTRL1);
    AR = setbit 14 of AR;
    DM(v_SongCTRL1) = AR;
    rts;

CTRL16:
    DM(a_Scalar + 3) = M0;
    AR = DM(v_DelayCNTR);
    AR = AR + 1;
    DM(v_DelayCNTR) = AR;
    AY0 = 10;
    AR = AR - AY0;
    if LT rts;
    
    DM(v_DelayCNTR) = M0;

EndSong29:
    AR = NOOUTPUT;
    DM(a_SimpSeq + (10*SEQVARS)+SEQ_ENV) = AR;
    DM(a_SimpSeq + (11*SEQVARS)+SEQ_ENV) = AR;
    DM(a_SimpSeq + (13*SEQVARS)+SEQ_ENV) = AR;
    DM(a_SimpSeq + (14*SEQVARS)+SEQ_ENV) = AR;
    DM(a_SimpSeq + (15*SEQVARS)+SEQ_ENV) = AR;
    DM(a_SimpSeq + (16*SEQVARS)+SEQ_ENV) = AR;
    
    AR = DM(v_DelayCNTR);
    AR = AR + 1;
    DM(v_DelayCNTR) = AR;
    AY0 = 1;
    AR = AR - AY0;
    if LT rts;
        
    pop CNTR, pop PC, pop LOOP;
    pop CNTR, pop PC, pop LOOP;
    pop CNTR, pop PC, pop LOOP;
    pop CNTR, pop PC, pop LOOP;
    pop CNTR, pop PC, pop LOOP;
    pop CNTR, pop PC, pop LOOP;
    pop CNTR, pop PC, pop LOOP;

    jump FRL;
#endif    
    rts;

.ENDMOD;


