/******************************************************************************
*
*  SongCTRL.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  function for modifying parameters on a measure by measure basis.  execution
*  rate determined by v_TicsPerMeasure (set in GenFXIni.dsp by macros).
*
******************************************************************************/

.MODULE                                     modSongCTRL_00;

/*
 *  include files for all functions
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "song3.h"

/*
 *  external variables and functions
 */

/*
 *  entry points
 */

.ENTRY      SongCTRL_00;
.ENTRY      Measure_JT;
.ENTRY      EndMeasure_JT;

SongCTRL_00:
    AR = DM(v_TicCNTR);
    AR = AR + 1;
    DM(v_TicCNTR) = AR;
    AY0 = DM(v_TicsPerMeasure);
    AR = AR - AY0;
    if LT rts;
    
    DM(v_TicCNTR) = M0;

/*
 *  note!  this initialization used to be in InitFunc.dsp.  however, to make
 *  this function work with multiple tracks in a single executable, Measure_JT
 *  and EndMeasure_JT would need to be abstracted and inited in SongPtrs.dsp.
 *  to try and simplify and reduce the number of initializations that occur in
 *  that function, these variables were made local and it is continually
 *  re-inited here.  note that this code runs in the krate loop so performance
 *  is not a concern.
 */

SetMeasuresPerSong:
    AX0 = ^EndMeasure_JT;
    AY0 = ^Measure_JT;
    AR = AX0 - AY0;
    DM(v_MeasuresPerSong) = AR;
    
    I5 = ^Measure_JT;
    M5 = DM(v_CurrMeasure);
    modify(I5, M5);
    jump (I5);
    
/*
 *  insert JT of operations to perform at the start of every new measure
 */
    
Measure_JT:
    jump Measure1;
EndMeasure_JT:

/*
 *  insert all multimeasure operations - for parameters that should be modified
 *  over multiple measures
 */

MultiMeasureCheck:

EndSongCheck:
    AR = DM(v_CurrMeasure);
    AR = AR + 1;
    DM(v_CurrMeasure) = AR;
    AY0 = DM(v_MeasuresPerSong);
    AR = AR - AY0;
    if LT rts;

/*
 *  SongCTRL list is complete.  jumping to EndSong will start the next song
 *  in a multisong environment.  resetting CurrMeasure starts the Measure_JT
 *  loop over again, causing the same song to play indefinitely
 */
    
    !jump EndSong;
    
    DM(v_CurrMeasure) = M0;
    rts;

MultiMeasureMod:
    AR = DM(v_CurrMeasure);   
    AY0 = SR0;       
    NONE = AR - AY0;         
    if LT jump EndMMM;
    AY0 = SR1;
    NONE = AR - AY0;
    if GT jump EndMMM;
    call (I5);
EndMMM:
    rts;

Measure1:

/*
 *  autogenerated code for SETTRACK macro
 */
    I2 = ^a_TrigTrack00;
    I3 = ^a_VolTrack00;
    CNTR = 128;
    do CL00114 until CE;
        DM(I2, M1) = 0;
CL00114:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack01;
    I3 = ^a_VolTrack01;
    CNTR = 128;
    do CL01114 until CE;
        DM(I2, M1) = 0;
CL01114:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack02;
    I3 = ^a_VolTrack02;
    CNTR = 128;
    do CL02114 until CE;
        DM(I2, M1) = 0;
CL02114:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack03;
    I3 = ^a_VolTrack03;
    CNTR = 128;
    do CL03114 until CE;
        DM(I2, M1) = 0;
CL03114:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack04;
    I3 = ^a_VolTrack04;
    CNTR = 128;
    do CL04114 until CE;
        DM(I2, M1) = 0;
CL04114:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack05;
    I3 = ^a_VolTrack05;
    CNTR = 128;
    do CL05114 until CE;
        DM(I2, M1) = 0;
CL05114:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack06;
    I3 = ^a_VolTrack06;
    CNTR = 128;
    do CL06114 until CE;
        DM(I2, M1) = 0;
CL06114:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack07;
    I3 = ^a_VolTrack07;
    CNTR = 128;
    do CL07114 until CE;
        DM(I2, M1) = 0;
CL07114:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack08;
    I3 = ^a_VolTrack08;
    CNTR = 128;
    do CL08114 until CE;
        DM(I2, M1) = 0;
CL08114:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack09;
    I3 = ^a_VolTrack09;
    CNTR = 128;
    do CL09114 until CE;
        DM(I2, M1) = 0;
CL09114:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack10;
    I3 = ^a_VolTrack10;
    CNTR = 128;
    do CL10114 until CE;
        DM(I2, M1) = 0;
CL10114:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack11;
    I3 = ^a_VolTrack11;
    CNTR = 128;
    do CL11114 until CE;
        DM(I2, M1) = 0;
CL11114:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack12;
    I3 = ^a_VolTrack12;
    CNTR = 128;
    do CL12114 until CE;
        DM(I2, M1) = 0;
CL12114:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack13;
    I3 = ^a_VolTrack13;
    CNTR = 128;
    do CL13114 until CE;
        DM(I2, M1) = 0;
CL13114:   DM(I3, M1) = 0;

    /* inits for a */
    AX0 = 100;
    AX1 = 0x3000;
    DM(a_TrigTrack00+0+0) = AX0;
    DM(a_VolTrack00+0+0) = AX1;
    DM(a_TrigTrack00+0+16) = AX0;
    DM(a_VolTrack00+0+16) = AX1;
    DM(a_TrigTrack00+0+28) = AX0;
    DM(a_VolTrack00+0+28) = AX1;

    /* inits for b */
    AX0 = 100;
    AX1 = 0x2000;
    DM(a_TrigTrack01+0+8) = AX0;
    DM(a_VolTrack01+0+8) = AX1;
    DM(a_TrigTrack01+0+14) = AX0;
    DM(a_VolTrack01+0+14) = AX1;
    DM(a_TrigTrack01+0+24) = AX0;
    DM(a_VolTrack01+0+24) = AX1;

    /* inits for c */
    AX0 = 100;
    AX1 = 0x0600;
    DM(a_TrigTrack02+0+4) = AX0;
    DM(a_VolTrack02+0+4) = AX1;
    DM(a_TrigTrack02+0+20) = AX0;
    DM(a_VolTrack02+0+20) = AX1;
    DM(a_TrigTrack02+0+30) = AX0;
    DM(a_VolTrack02+0+30) = AX1;

    /* inits for d */
    AX0 = 100;
    AX1 = 0x0100;
    DM(a_TrigTrack03+0+2) = AX0;
    DM(a_VolTrack03+0+2) = AX1;
    DM(a_TrigTrack04+0+2) = AX0;
    DM(a_VolTrack04+0+2) = AX1;
    DM(a_TrigTrack03+0+8) = AX0;
    DM(a_VolTrack03+0+8) = AX1;
    DM(a_TrigTrack04+0+8) = AX0;
    DM(a_VolTrack04+0+8) = AX1;
    DM(a_TrigTrack03+0+16) = AX0;
    DM(a_VolTrack03+0+16) = AX1;
    DM(a_TrigTrack04+0+16) = AX0;
    DM(a_VolTrack04+0+16) = AX1;
    DM(a_TrigTrack03+0+24) = AX0;
    DM(a_VolTrack03+0+24) = AX1;
    DM(a_TrigTrack04+0+24) = AX0;
    DM(a_VolTrack04+0+24) = AX1;
    DM(a_TrigTrack03+0+26) = AX0;
    DM(a_VolTrack03+0+26) = AX1;
    DM(a_TrigTrack04+0+26) = AX0;
    DM(a_VolTrack04+0+26) = AX1;
    DM(a_TrigTrack03+0+28) = AX0;
    DM(a_VolTrack03+0+28) = AX1;
    DM(a_TrigTrack04+0+28) = AX0;
    DM(a_VolTrack04+0+28) = AX1;

    /* inits for e */
    AX0 = 100;
    AX1 = 0x2000;
    DM(a_TrigTrack05+0+8) = AX0;
    DM(a_VolTrack05+0+8) = AX1;
    DM(a_TrigTrack06+0+8) = AX0;
    DM(a_VolTrack06+0+8) = AX1;
    DM(a_TrigTrack05+0+24) = AX0;
    DM(a_VolTrack05+0+24) = AX1;
    DM(a_TrigTrack06+0+24) = AX0;
    DM(a_VolTrack06+0+24) = AX1;

    /* inits for f */
    AX0 = 100;
    AX1 = 0x1800;
    DM(a_TrigTrack07+0+0) = AX0;
    DM(a_VolTrack07+0+0) = AX1;
    DM(a_TrigTrack08+0+0) = AX0;
    DM(a_VolTrack08+0+0) = AX1;
    DM(a_TrigTrack07+0+2) = AX0;
    DM(a_VolTrack07+0+2) = AX1;
    DM(a_TrigTrack08+0+2) = AX0;
    DM(a_VolTrack08+0+2) = AX1;
    DM(a_TrigTrack07+0+4) = AX0;
    DM(a_VolTrack07+0+4) = AX1;
    DM(a_TrigTrack08+0+4) = AX0;
    DM(a_VolTrack08+0+4) = AX1;
    DM(a_TrigTrack07+0+6) = AX0;
    DM(a_VolTrack07+0+6) = AX1;
    DM(a_TrigTrack08+0+6) = AX0;
    DM(a_VolTrack08+0+6) = AX1;
    DM(a_TrigTrack07+0+12) = AX0;
    DM(a_VolTrack07+0+12) = AX1;
    DM(a_TrigTrack08+0+12) = AX0;
    DM(a_VolTrack08+0+12) = AX1;
    DM(a_TrigTrack07+0+14) = AX0;
    DM(a_VolTrack07+0+14) = AX1;
    DM(a_TrigTrack08+0+14) = AX0;
    DM(a_VolTrack08+0+14) = AX1;
    DM(a_TrigTrack07+0+16) = AX0;
    DM(a_VolTrack07+0+16) = AX1;
    DM(a_TrigTrack08+0+16) = AX0;
    DM(a_VolTrack08+0+16) = AX1;
    DM(a_TrigTrack07+0+18) = AX0;
    DM(a_VolTrack07+0+18) = AX1;
    DM(a_TrigTrack08+0+18) = AX0;
    DM(a_VolTrack08+0+18) = AX1;
    DM(a_TrigTrack07+0+19) = AX0;
    DM(a_VolTrack07+0+19) = AX1;
    DM(a_TrigTrack08+0+19) = AX0;
    DM(a_VolTrack08+0+19) = AX1;
    DM(a_TrigTrack07+0+20) = AX0;
    DM(a_VolTrack07+0+20) = AX1;
    DM(a_TrigTrack08+0+20) = AX0;
    DM(a_VolTrack08+0+20) = AX1;
    DM(a_TrigTrack07+0+22) = AX0;
    DM(a_VolTrack07+0+22) = AX1;
    DM(a_TrigTrack08+0+22) = AX0;
    DM(a_VolTrack08+0+22) = AX1;
    DM(a_TrigTrack07+0+26) = AX0;
    DM(a_VolTrack07+0+26) = AX1;
    DM(a_TrigTrack08+0+26) = AX0;
    DM(a_VolTrack08+0+26) = AX1;
    DM(a_TrigTrack07+0+28) = AX0;
    DM(a_VolTrack07+0+28) = AX1;
    DM(a_TrigTrack08+0+28) = AX0;
    DM(a_VolTrack08+0+28) = AX1;
    DM(a_TrigTrack07+0+30) = AX0;
    DM(a_VolTrack07+0+30) = AX1;
    DM(a_TrigTrack08+0+30) = AX0;
    DM(a_VolTrack08+0+30) = AX1;
    DM(a_TrigTrack07+0+31) = AX0;
    DM(a_VolTrack07+0+31) = AX1;
    DM(a_TrigTrack08+0+31) = AX0;
    DM(a_VolTrack08+0+31) = AX1;

    /* inits for g */
    AX0 = 100;
    AX1 = 0x0800;
    DM(a_TrigTrack09+0+0) = AX0;
    DM(a_VolTrack09+0+0) = AX1;
    DM(a_TrigTrack09+0+22) = AX0;
    DM(a_VolTrack09+0+22) = AX1;

    /* inits for h */
    AX0 = 100;
    AX1 = 0x1000;
    DM(a_TrigTrack10+0+0) = AX0;
    DM(a_VolTrack10+0+0) = AX1;
    DM(a_TrigTrack11+0+0) = AX0;
    DM(a_VolTrack11+0+0) = AX1;
    DM(a_TrigTrack10+0+12) = AX0;
    DM(a_VolTrack10+0+12) = AX1;
    DM(a_TrigTrack11+0+12) = AX0;
    DM(a_VolTrack11+0+12) = AX1;
    DM(a_TrigTrack10+0+24) = AX0;
    DM(a_VolTrack10+0+24) = AX1;
    DM(a_TrigTrack11+0+24) = AX0;
    DM(a_VolTrack11+0+24) = AX1;

    /* inits for i */
    AX0 = 50;
    AX1 = 0x0c00;
    DM(a_TrigTrack10+0+2) = AX0;
    DM(a_VolTrack10+0+2) = AX1;
    DM(a_TrigTrack11+0+2) = AX0;
    DM(a_VolTrack11+0+2) = AX1;
    DM(a_TrigTrack10+0+4) = AX0;
    DM(a_VolTrack10+0+4) = AX1;
    DM(a_TrigTrack11+0+4) = AX0;
    DM(a_VolTrack11+0+4) = AX1;
    DM(a_TrigTrack10+0+10) = AX0;
    DM(a_VolTrack10+0+10) = AX1;
    DM(a_TrigTrack11+0+10) = AX0;
    DM(a_VolTrack11+0+10) = AX1;
    DM(a_TrigTrack10+0+14) = AX0;
    DM(a_VolTrack10+0+14) = AX1;
    DM(a_TrigTrack11+0+14) = AX0;
    DM(a_VolTrack11+0+14) = AX1;
    DM(a_TrigTrack10+0+16) = AX0;
    DM(a_VolTrack10+0+16) = AX1;
    DM(a_TrigTrack11+0+16) = AX0;
    DM(a_VolTrack11+0+16) = AX1;
    DM(a_TrigTrack10+0+20) = AX0;
    DM(a_VolTrack10+0+20) = AX1;
    DM(a_TrigTrack11+0+20) = AX0;
    DM(a_VolTrack11+0+20) = AX1;
    DM(a_TrigTrack10+0+26) = AX0;
    DM(a_VolTrack10+0+26) = AX1;
    DM(a_TrigTrack11+0+26) = AX0;
    DM(a_VolTrack11+0+26) = AX1;

    /* inits for j */
    AX0 = 20;
    AX1 = 0x0800;
    DM(a_TrigTrack10+0+8) = AX0;
    DM(a_VolTrack10+0+8) = AX1;
    DM(a_TrigTrack11+0+8) = AX0;
    DM(a_VolTrack11+0+8) = AX1;
    DM(a_TrigTrack10+0+22) = AX0;
    DM(a_VolTrack10+0+22) = AX1;
    DM(a_TrigTrack11+0+22) = AX0;
    DM(a_VolTrack11+0+22) = AX1;
    DM(a_TrigTrack10+0+28) = AX0;
    DM(a_VolTrack10+0+28) = AX1;
    DM(a_TrigTrack11+0+28) = AX0;
    DM(a_VolTrack11+0+28) = AX1;
    DM(a_TrigTrack10+0+30) = AX0;
    DM(a_VolTrack10+0+30) = AX1;
    DM(a_TrigTrack11+0+30) = AX0;
    DM(a_VolTrack11+0+30) = AX1;

    /* inits for k */
    AX0 = 100;
    AX1 = 0x0c00;
    DM(a_TrigTrack12+0+0) = AX0;
    DM(a_VolTrack12+0+0) = AX1;
    DM(a_TrigTrack12+0+22) = AX0;
    DM(a_VolTrack12+0+22) = AX1;

    /* inits for l */
    AX0 = 100;
    AX1 = 0x0700;
    DM(a_TrigTrack13+0+0) = AX0;
    DM(a_VolTrack13+0+0) = AX1;
    DM(a_TrigTrack13+0+22) = AX0;
    DM(a_VolTrack13+0+22) = AX1;

/* donotparse(CLEAR, 0, 0,  a--- ---- ---- ----  a--- ---- ---- a---,
            CLEAR, 0, 1,  ---- ---- b--- --b-  ---- ---- b--- ----,
            CLEAR, 0, 2,  ---- c--- ---- ----  ---- c--- ---- --c-,
            CLEAR, 0, 3,  --d- ---- d--- ----  d--- ---- d-d- d---,
            CLEAR, 0, 4,  --d- ---- d--- ----  d--- ---- d-d- d---,
            CLEAR, 0, 5,  ---- ---- e--- ----  ---- ---- e--- ----,
            CLEAR, 0, 6,  ---- ---- e--- ----  ---- ---- e--- ----,
            CLEAR, 0, 7,  f-f- f-f- ---- f-f-  f-ff f-f- --f- f-ff,
            CLEAR, 0, 8,  f-f- f-f- ---- f-f-  f-ff f-f- --f- f-ff,
            CLEAR, 0, 9,  g--- ---- ---- ----  ---- --g- ---- ----,
            CLEAR, 0, 10, h-i- i--- j-i- h-i-  i--- i-j- h-i- j-j-,
            CLEAR, 0, 11, h-i- i--- j-i- h-i-  i--- i-j- h-i- j-j-,
            CLEAR, 0, 12, k--- ---- ---- ----  ---- --k- ---- ----,
            CLEAR, 0, 13, l--- ---- ---- ----  ---- --l- ---- ----,
            a, 100, 0x3000,
            b, 100, 0x2000,
            c, 100, 0x0600,
            d, 100, 0x0100,
            e, 100, 0x2000,
            f, 100, 0x1800,
            g, 100, 0x0800,
            h, 100, 0x1000,
            i, 50,  0x0c00,
            j, 20,  0x0800,
            k, 100, 0x0c00,
            l, 100, 0x0700,
            END); */



    jump MultiMeasureCheck;

.ENDMOD;
