/******************************************************************************
*
*  moeGens.dsp
*  
*  generative music initializing routine
*
******************************************************************************/

.MODULE                                     modmoeGens_29;

/*
 *  include files for all functions
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "t29.h"

/*
 *  external variables and functions
 */

/*
 *  entry points
 */

.ENTRY      GenFX_29;
.ENTRY      Mixer_29;
.ENTRY      Env_29;

GenFX_29:
    ! tri0 (scalar)
    call WTGen2;
    modify(I7, M7);

    ! tri1 (scalar)
    call WTGen2;
    modify(I7, M7);

    ! tri0 FM tri1 (scalar)
    call OscCombGen;
    modify(I7, M7);
 
    ! tri0 LOFIFM tri1 (scalar)
    call OscCombGen;
    modify(I7, M7);

    ! bd1 (adsr)
    call WTGen;
    call WaveshapeFX;
    modify(I7, M7);

    ! ks1 (adsr)
    call KSGen;
    call GenSHFX;
    modify(I7, M7);
   
    ! bd2 (adsr)
    call WTGen;
    call WaveshapeFX;
    modify(I7, M7);

    ! ks2 (adsr)
    call KSGen;
    call GenSHFX;
    modify(I7, M7);

    ! ks3 (scalar)
    call KSGen;
    call GenSHFX;
    modify(I7, M7);

    ! ks4 (scalar)
    call KSGen;
    call GenSHFX;
    modify(I7, M7);

    ! rot1 (adsr)
    call RotSynthGen;        
    modify(I7, M7);

    ! rot2 (adsr)
    call RotSynthGen;
    modify(I7, M7);
   
    ! tri0 xor tri0 (adsr)
    call OscCombGen;
    modify(I7, M7);
    
    ! rot3 (adsr)
    call RotSynthGen;
    modify(I7, M7);
   
    ! rot4 (adsr)
    call RotSynthGen;
    modify(I7, M7);
   
    ! rot5 (adsr)
    call RotSynthGen;
    modify(I7, M7);
    
    ! rot6 (adsr)
    call RotSynthGen;
    modify(I7, M7);
    
    ! ks5
    call KSGen;
    modify(I7, M7);
    
    ! ks6
    call KSGen;
    modify(I7, M7);
    
    /* move ptr back to top of a_GenData for scaling */
    AR = ^a_GenData;
    DM(p_GenData) = AR;
    
    /* stop borrowing I7 for a_GenData */
    I7 = ^a_RSampOut;
    L7 = %a_RSampOut;
/*
 *  envelopes automatically placed by GenFXIniPostProc - max num of tracks set
 *  by MAXTRACKS.  if this value is changed, muts add more nop to accomidate
 */

Env_29:
    nop;    nop;    nop;    nop;
    nop;    nop;    nop;    nop;
    nop;    nop;    nop;    nop;
    nop;    nop;    nop;    nop;
    nop;    nop;    nop;    nop;
    nop;    nop;    nop;    nop;
    nop;    nop;    nop;    nop;
    nop;    nop;    nop;    nop;
        
    rts;

Mixer_29:
    /* invert righ channel */
    AR = DM(a_RSampOut+T_KS1);
    AR = -AR;
    DM(a_RSampOut+T_KS1) = AR;
    AR = DM(a_RSampOut+T_KS2);
    AR = -AR;
    DM(a_RSampOut+T_KS2) = AR;
    AR = DM(a_RSampOut+T_KS3);
    AR = -AR;
    DM(a_RSampOut+T_KS3) = AR;
    AR = DM(a_RSampOut+T_KS4);
    AR = -AR;
    DM(a_RSampOut+T_KS4) = AR;
    
    AR = DM(a_RSampOut+T_ROT1);
    AR = -AR;
    DM(a_RSampOut+T_ROT1) = AR;
    AR = DM(a_RSampOut+T_ROT2);
    AR = -AR;
    DM(a_RSampOut+T_ROT2) = AR;
    AR = DM(a_RSampOut+T_ROT3);
    AR = -AR;
    DM(a_RSampOut+T_ROT3) = AR;
    AR = DM(a_RSampOut+T_ROT4);
    AR = -AR;
    DM(a_RSampOut+T_ROT4) = AR;
    AR = DM(a_RSampOut+T_ROT5);
    AR = -AR;
    DM(a_RSampOut+T_ROT5) = AR;
    AR = DM(a_RSampOut+T_ROT6);
    AR = -AR;
    DM(a_RSampOut+T_ROT6) = AR;
    
    AR = DM(a_RSampOut+T_OSCCOMB3);
    AR = -AR;
    DM(a_RSampOut+T_OSCCOMB3) = AR;

    call LBasicMix;
      
    /* insert global LChan processing here (any FX functions) */
    
    /* readback from I7, write data to output array.  do not remove! */
    AR = DM(I7, M6);
    I7 = DM(p_LOutBuff);                /* get ptr to LOutBuff */
    L7 = OUTBUFFLEN;
    DM(I7, M7) = AR;                    /* write output to OutBuff0 or 1 */
    DM(p_LOutBuff) = I7;                /* update ptr */
    
    call RBasicMix;
      
    /* insert global RChan processing here (any FX functions) */

    /* readback from I7, write data to output array.  do not remove! */
    AR = DM(I7, M6);
    I7 = DM(p_ROutBuff);                /* get ptr to ROutBuff */
    L7 = OUTBUFFLEN;
    DM(I7, M7) = AR;                    /* write output to OutBuff0 or 1 */
    DM(p_ROutBuff) = I7;                /* update ptr */
        
    rts;
      
.ENDMOD;
