##
 #  create a new project from an existing project
 #
 #  0.  make new directory callled newprojname
 #  1.  replace #include "oldproname.h" with #include "newprojname.h"
 #  2.  change oldprojname.mak to be newprojname.mak
 #  3.  change oldprojnameVars.dsp to newprojnameVars.dsp
 #  4.  change oldprojnameVars.dsp to newprojnameVars.dsp in newprojname.mak
 #  5.  change oldprojname.h, oldprojnamevars.h and oldprojnamedefs.h to
 #      newprojname.h, newprojnamevars.h and newprojnamedef.h
 #  6.  change oldprojnamevars.h and oldprojnamedefs.h to newprojnamevars.h and
 #      newprojnamedefs.h in newprojname.h
 ##

#!/usr/bin/perl

# define new and old project vars
$oldprojname = $ARGV[0];
$newprojname = $ARGV[1];

die "\n  cloneproj [oldproj] [newproj]\n" if !defined($ARGV[0]);
die "\n  cloneproj [oldproj] [newproj]\n" if !defined($ARGV[1]);

$oldprojpath = "..\\$oldprojname\\";
$oldprojhdrpath = "..\\$oldprojname\\hdr\\";

$newprojpath = "..\\$newprojname\\";
$newprojhdrpath = "..\\$newprojname\\hdr\\";
$newprojobjpath = "..\\$newprojname\\obj\\";

# check if old proj exists and new one doesn't
open (DIRCHECK, "$oldprojpath".'\\SongPtrs.dsp')
    or die "\n  $oldprojname doesn't exist!\n";
close DIRCHECK;

open (DIRCHECK, "$newprojpath".'\\SongPtrs.dsp');
($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size) = stat("$newprojpath".'\\SongPtrs.dsp');
if ($size)
{
    die "\n  $newprojname project exists!  delete project before continuing...\n";
}

# make new project directory, including hdr and obj
mkdir $newprojpath, 0777;
mkdir $newprojobjpath, 0777;
mkdir $newprojhdrpath, 0777;

# get filelist from old directory
@oldfiles = glob "..\\$oldprojname\\*.*";
@oldhdrfiles = glob "..\\$oldprojname\\hdr\\*.*";

# @snipfile holds filelist without path
$sniplen = length($oldprojpath);
foreach $fileline (@oldfiles)
{
    $snipfile[$i++] = substr($fileline, $sniplen);
}
$sniphdrlen = length($oldprojhdrpath);
foreach $hdrfileline (@oldhdrfiles)
{
    $sniphdrfile[$j++] = substr($hdrfileline, $sniphdrlen);
}

$filecntr = 0;
$hdrfilecntr = 0;

    $filematch1 = "$oldprojname"."Vars.dsp";
    $filematch2 = "$oldprojname"."notes.txt";

foreach $oldfileline (@oldfiles)
{
    # oldproj.mak case
    if ($oldfiles[$filecntr] =~ /.mak/)
    {
        &makfile;
    }
    # oldprojVars.dsp case;
    elsif ($oldfiles[$filecntr] =~ /$filematch1/)
    {
        &varfile;
    }
    # oldproj.txt case
    elsif ($oldfiles[$filecntr] =~ /$filematch2/)
    {
        &notesfile;
    }
    # every other file
    else
    {
        &allotherfiles;
    }
    $filecntr++;
}

    $hdrmatch1 = "$oldprojname".".h";
    $hdrmatch2 = "$oldprojname"."defs.h";
    $hdrmatch3 = "$oldprojname"."vars.h";

foreach $oldhdrfileline (@oldhdrfiles)
{
    if ($oldhdrfiles[$hdrfilecntr] =~ /$hdrmatch2/ ||
        $oldhdrfiles[$hdrfilecntr] =~ /$hdrmatch3/ )
    {
        &hdrvarsdefsfiles;
    }
    elsif ($oldhdrfiles[$hdrfilecntr] =~ /$hdrmatch1/)
    {
        &mainhdrfile;
    }
    else
    {
        &allotherhdrfiles;
    }
    $hdrfilecntr++;
}

print "  done processing $oldprojname, created $newprojname\n";

#
#  change name of file, change name of templateVars to projnameVars
#

sub makfile
{   
    # open template.mak, create projname.mak
    open(MAKREAD, $oldfiles[$filecntr]);
    @makcode = <MAKREAD>;
    open(MAKWRITE, ">$newprojpath".$newprojname.'.mak');
    
    $makmatch1 = "$oldprojname"."Vars.dsp";
    
    foreach $makline (@makcode) {
        if($makline =~ /$makmatch1/)
        {
            $makline = 'GASRC = '.$newprojname.'Vars.dsp \\'."\n";
        }
        print MAKWRITE "$makline";
    }
    close MAKREAD;
    close MAKWRITE;
}

#
#  change name of file, change #include
#

sub varfile
{
    # open oldprojVars.dsp, create newprojVars.dsp
    open(VARREAD, $oldfiles[$filecntr]);
    @varcode = <VARREAD>;
    open(VARWRITE, ">$newprojpath".$newprojname.'Vars.dsp');

    $match1 = "$oldprojname".".h";
    $match2 = "  "."$oldprojname"."Vars.dsp";
    $match3 = ".MODULE";

    foreach $varline (@varcode) {
        if($varline =~ /$match1/)
        {
            $varline = "#include    ".'"'."$newprojname".".h".'"'."\n";
        }
        elsif($varline =~ /$match2/)
        {
            $varline = "*  "."$newprojname"."Vars.dsp"."\n";
        }
        elsif($varline =~ /$match3/)
        {
            $varline = ".MODULE                                     mod"."$newprojname"."Vars;"."\n";
        }
        print VARWRITE "$varline";
    }
    close VARWRITE;
    close VARREAD;
}

sub notesfile
{
    open(OLDTXTREAD, $oldfiles[$filecntr]);
    @oldtxtcode = <OLDTXTREAD>;
    open(NEWTXTWRITE, ">$newprojpath"."$newprojname"."notes.txt");
    
    foreach $oldtxtline (@oldtxtcode)
    {
        print NEWTXTWRITE "$oldtxtline";
    }
    close OLDTXTREAD;
    close NEWTXTWRITE;
}

sub allotherfiles
{
    $inclinefound = 0;
    
    # open .dsp file, create new version in projname directory
    open(FILEREAD, $oldfiles[$filecntr]);
    @oldfilecode = <FILEREAD>;
    open(FILEWRITE, ">$newprojpath"."@snipfile[$filecntr]");
    
    $inccheck = "$oldprojname".".h";
    
    foreach $fileline (@oldfilecode)
    {
        if($fileline =~ /$inccheck/)
        {
            $inclinefound = 1;
            $fileline = "#include    ".'"'."$newprojname".".h".'"';
        }
        print FILEWRITE "$fileline";
        if ($inclinefound eq "1")
        {
            print FILEWRITE "\n";
            $inclinefound = 0;
        }
    }
    close FILEREAD;
    close FILEWRITE;
}

sub mainhdrfile
{
    # open oldproj.h file, create new version in newproj directory
    open(MAINHDRREAD, $oldhdrfiles[$hdrfilecntr]);
    @oldhdrfilecode = <MAINHDRREAD>;
    open(MAINHDRWRITE, ">$newprojhdrpath"."$newprojname.h");
    
    foreach $hdrfileline (@oldhdrfilecode)
    {
        if($hdrfileline =~ /$hdrmatch3/)
        {
            $hdrfileline = "#include ".'"'."$newprojname"."vars.h".'"'."\n";
        }
        elsif($hdrfileline =~ /$hdrmatch2/)
        {
            $hdrfileline = "#include ".'"'."$newprojname"."defs.h".'"'."\n";
        }
        print MAINHDRWRITE "$hdrfileline";
    }
    close MAINHDRWRITE;
    close MAINHDRREAD;
}

sub allotherhdrfiles
{
    open(HDRREAD, $oldhdrfiles[$hdrfilecntr]);
    @hdrfilecode = <HDRREAD>;
    open(HDRWRITE, ">$newprojhdrpath"."$sniphdrfile[$hdrfilecntr]");
    print "$newprojhdrpath"."$sniphdrfile";
    foreach $hdrfileline (@hdrfilecode)
    {
        print HDRWRITE "$hdrfileline";
    }
    close HDRREAD;
    close HDRWRITE;
}    
 
sub hdrvarsdefsfiles
{
    open(HDRREAD, $oldhdrfiles[$hdrfilecntr]);
    @hdrfilecode = <HDRREAD>;
    if ($oldhdrfiles[$hdrfilecntr] =~ /vars.h/)
    {
        open(HDRWRITE, ">$newprojhdrpath"."$newprojname"."vars.h");
    }
    else
    {
        open(HDRWRITE, ">$newprojhdrpath"."$newprojname"."defs.h");
    }
    foreach $hdrfileline (@hdrfilecode)
    {
        print HDRWRITE "$hdrfileline";
    }
    close HDRREAD;
    close HDRWRITE;
}    